        .386
        .MODEL flat, stdcall

        PUBLIC  Compare
        extrn WadeSpace : PROC, ReadNumber :PROC, PrintWord : PROC
        extrn WriteChar : PROC, PrintByte : PROC, PrintSpace : PROC
        extrn ReadAddress : PROC, membase : dword, PrintDword : PROC
        extrn membase : dword, memtop : dword, crlf : PROC
	.CODE

;INPUT: AL has byte (two hex chars) to print

pbyte	PROC
	call	PrintByte
        call    PrintSpace
	ret
pbyte	ENDP

;
; Compare command
; syntax is c start,end,start2
;
Compare PROC
	call	WadeSpace		;find source address
	jz	errx			;not found (end of input)
        call    ReadAddress
	jc	errx			;not found
	push	ebx			;and starting offset
	call	WadeSpace		;see if any more
	jz	errx2			;nope, didn't find
	call	ReadNumber		; read ending offset
	jc	errx2			;not found
	mov	ecx,eax			;get ending offset into ECX
        cmp     eax,[memtop]
        jae     errx2
	sub	ecx,ebx			;subtract starting offset
	jb	errx2			;error if end < start
	call	WadeSpace		;else keep reading input
	jz	errx2			;need a destination
        call    ReadAddress
	jc	errx2			;not found
	call	WadeSpace		;make sure no more
	jnz	errx2			;if more, syntax error
	pop	esi    			;get start ofs from stack to ESI
	mov	edi,ebx			;and ending offset to EDI
        add     esi,[membase]
        add     edi,[membase]
clp:
	repe	cmpsb			;cmp ds:[esi] with es:[edi]
	mov	al,ds:[esi-1]		;differing byte from source in AL
	mov	ah,es:[edi-1]		;and dest in AH
	jz	cdone			;no difference in this case
        push    eax                      ;save differing bytes
	call	crlf			;new line
	mov	eax,esi			;location where different
	dec	eax			;minus cmpsb moved ESI past it
        sub     eax,[membase]
        call    PrintDword
        call    PrintSpace
        pop     eax                      ;restore differing bytes
	push	ax			;and save them again
	call	pbyte			;show source byte
	pop	ax			;get them back
	mov	al,ah			;setup dest byte
	call	pbyte			;and show that
	mov	eax,edi			;get dest offset
	dec	eax			;minus correction for cmps
        sub     eax,[membase]
        call    PrintDword                   ;show dest seg:ofs
	jmp	clp			;find next difference
	
cdone:
	clc				; to clean up stack
	ret
errx2:
        pop     eax
errx:
	stc
	ret
Compare endp
end