         .486                
        .model flat,stdcall

include opcode.inc
include operand.inc
        public ExecuteInstruction, prm_00,oldsr

        extrn   dbg_find_opcode : PROC, dbg_sz_dispatch : PROC
        extrn   thesize : byte, dbg_op1 : operand, dbg_op2:operand
        extrn   dbg_op3: operand, oldpc : dword, dbg_op_dispatch : PROC
        extrn   membase : dword, memtop : dword
        extrn   Dregs : dword, SR : dword, hasvects : dword
        extrn   emuload : PROC, emustore : PROC, firstword : dword
        extrn   USP: dword ,ISP : dword ,MSP : dword, VBR : dword
        extrn   WriteString : PROC, PrintByte : PROC
        extrn   emuparms : DWORD, DregTop : DWORD
        .data
prm_00  db      0       ; 68000
changeofflow db 0
badtrapnum db   0
stopped db 0
oldsr   dw      0       ;
DebuggerTrap db 13,10,"--->Trap to simulator: ",0
StoppedMsg db   13,10,"--->Stop instruction executed, halting",0

        .code
NOX_MASK = 0f0ffffffh
NOF_MASK = 0e0ffffffh
C_BIT = 24
V_BIT = 25
Z_BIT = 26
N_BIT = 27
X_BIT = 28
TRACE_BIT = 23
TRACE_BIT2 = 22
SUPERV_BIT = 21
MASTER_BIT = 20
INVALID_SR_BITS = 1ff70000h
INVALID_CCR_BITS = 1fh

regn PROC
        movzx   ecx,[edi + operand.r1]
        lea     ecx,[Dregs + 4 * ecx]
        ret
regn ENDP
aindr PROC
        movzx   ecx,[edi + operand.r1]
        mov     ecx,[Dregs + 4 * ecx]
        bswap   ecx
        add     ecx,[membase]
        ret
aindr ENDP
apostinc PROC
        movzx   ebp,[edi + operand.r1]
        lea     ebp,[Dregs + 4 * ebp]
        mov     ecx,[ebp]
        bswap   ecx
        add     ecx,[membase]
        ret
apostinc ENDP
apredec PROC
        movzx   ebp,[edi + operand.r1]
        lea     ebp,[Dregs + 4 * ebp]
        mov     ecx,[ebp]
        bswap   ecx
        add     ecx,[membase]
        ret
apredec ENDP
aindex PROC
        movsx   ecx,word ptr [edi + operand.bd]
        movzx   edx,[edi + operand.r1]
        mov     edx,[Dregs + 4 * edx]
        bswap   edx
        add     ecx,edx
        add     ecx,[membase]
        ret
aindex ENDP
pcindex PROC
        mov     ecx,[edi + operand.bd]
        add     ecx,[membase]
        ret
pcindex ENDP
based PROC
        mov     eax,[edi + operand.bd]
        movzx   edx,[edi + operand.r1]
        mov     edx,[Dregs + 4 * edx]
        bswap   edx
        add     eax,edx
        add     eax,[membase]
addindex:
        movzx   ebp,[edi + operand.r2]
        lea     ebp,[Dregs + 4 * ebp]
        movzx   edx,[edi + operand.mods]
        mov     ecx,edx
        and     edx,3
        jmp     [edx * 4 + basedregsize]
basedregsize LABEL DWORD
        dd      basedbyte,basedword,baseddword
basedbyte:
        movsx   edx,byte ptr [ebp+3]
        jmp     basedcont
basedword:
        mov     dx,word ptr [ebp+2]
        xchg    dl,dh
        movsx   edx,dx
        jmp     basedcont
baseddword:
        mov     edx,[ebp]
        bswap   edx
basedcont:
        shr     ecx,2
        and     ecx,3
        shl     edx,cl
        mov     ecx,eax
        add     ecx,edx
        ret
based ENDP
mem PROC
        mov     ecx,[edi + operand.bd]
        test    [edi + operand.mods],BASESUPPRESS
        jnz     nobase
        movzx   ebp,[edi + operand.r1]
        mov     ebp,[Dregs + 4 * ebp]
        bswap   ebp
        add     ecx,ebp
nobase:
        add     ecx,[membase]
        test    [edi + operand.mods],INDEXSUPPRESS
        jnz      nopre
        test    [edi + operand.mods],POSTINDEX
        jnz     nopre
        mov     eax,ecx
        call    addindex
nopre:
        mov     ecx,[ecx]
        bswap   ecx
        add     ecx,[membase]
        test    [edi + operand.mods],INDEXSUPPRESS
        jnz      nopost
        test    [edi + operand.mods],POSTINDEX
        jz     nopost
        mov     eax,ecx
        call    addindex
nopost:
        add     ecx,[edi + operand.od]
        ret
mem ENDP
pcbased PROC
        mov     eax,[edi + operand.bd]
        add     eax,[membase]
        jmp     addindex
pcbased ENDP
pcmem PROC
        mov     ecx,[edi + operand.bd]
        add     ecx,[membase]
        test    [edi + operand.mods],INDEXSUPPRESS
        jnz     nopre2
        test    [edi + operand.mods],POSTINDEX
        jnz     nopre2
        mov     eax,ecx
        call    addindex
nopre2:
        mov     ecx,[ecx]
        bswap   ecx
        add     ecx,[membase]
        test    [edi + operand.mods],INDEXSUPPRESS
        jnz     nopost2
        test    [edi + operand.mods],POSTINDEX
        jz      nopost2
        mov     eax,ecx
        call    addindex
nopost2:
        add     ecx,[edi + operand.od]
        ret
pcmem ENDP
imm PROC
        lea     ecx,[edi + operand.bd]
        ret
imm ENDP
absw PROC
        movsx   ecx,word ptr [edi + operand.bd]
        add     ecx,[membase]
        ret
absw ENDP
absl PROC
        mov     ecx,[edi + operand.bd]
        add     ecx,[membase]
        ret
absl ENDP
bf PROC
        mov     ecx,-1
        ret
bf ENDP
mdreg PROC
        mov     ecx,-1
        ret
mdreg ENDP
cas2reg PROC
        mov     ecx,-1
        ret
cas2reg ENDP
cas2reg2 PROC
        mov     ecx,-1
        ret
cas2reg2 ENDP
movecreg PROC
        mov     ecx,-1
        ret
movecreg ENDP
nmovem PROC
        mov     ecx,-1
        ret
nmovem ENDP
rel PROC
        lea     ecx,[edi + operand.bd]
        ret
rel ENDP

opertable LABEL DWORD
        dd    none, regn, aindr
        dd    apostinc, apredec, aindex
        dd    pcindex, based, mem
        dd    pcbased, pcmem, imm
        dd    absw, absl, bf
        dd    mdreg, cas2reg, cas2reg2
        dd    movecreg, nmovem, rel

getAddress PROC
        movzx   edx,[edi + operand.xtype]
        sub     ecx,ecx
        jmp     [opertable + edx * 4]
none:
        stc
        ret
getAddress ENDP

lbyte PROC
        mov     dx,[edi + operand.xtype]
        cmp     dl,APREDEC
        jnz     blpre
        sub     byte ptr [ebp+3],1
        sbb     byte ptr [ebp+2],0
        sbb     byte ptr [ebp+1],0
        sbb     byte ptr [ebp],0
        dec     ecx
blpre:
        push    ecx
        cmp     ecx,[membase]
        jc      emubl
        cmp     ecx,[memtop]
        jc      purebl
emubl:
        mov     eax,[emuparms]
        cmp     ecx,[eax+4]
        jc      regbl
        cmp     ecx,[eax+8]
        ja      regbl
        call    emuload
        jmp     bljoin
regbl:
        cmp     ecx,offset Dregs
        jc      bljoin
        cmp     ecx,offset DregTop-1
        ja      bljoin
        add     ecx,3
purebl:
        mov     al,[ecx]
bljoin:
        pop     ecx
        cmp     dl,APOSTINC
        jnz     blpost
        add     byte ptr [ebp+3],1
        adc     byte ptr [ebp+2],0
        adc     byte ptr [ebp+1],0
        adc     byte ptr [ebp],0
blpost:
        ret
lbyte ENDP
lword PROC
        mov     dx,[edi + operand.xtype]
        cmp     dl,APREDEC
        jnz     wlpre
        sub     byte ptr [ebp+3],2
        sbb     byte ptr [ebp+2],0
        sbb     byte ptr [ebp+1],0
        sbb     byte ptr [ebp],0
        dec     ecx
        dec     ecx
wlpre:
        push    ecx
        cmp     ecx,[membase]
        jc      emuwl
        cmp     ecx,[memtop]
        jc      purewl
emuwl:
        mov     eax,[emuparms]
        cmp     ecx,[eax+4]
        jc      regwl
        cmp     ecx,[eax+8]
        ja      regwl
        call    emuload
        jmp     wljoin
regwl:
        cmp     ecx,offset Dregs
        jc      wljoin
        cmp     ecx,offset DregTop-2
        ja      wljoin
        add     ecx,2
purewl:
        mov     ax,[ecx]
        xchg    al,ah
wljoin:
        pop     ecx
        cmp     dl,APOSTINC
        jnz     wlpost
        add     byte ptr [ebp+3],2
        adc     byte ptr [ebp+2],0
        adc     byte ptr [ebp+1],0
        adc     byte ptr [ebp],0
wlpost:
        ret
lword ENDP
ldword PROC
        mov     dx,[edi + operand.xtype]
        cmp     dl,APREDEC
        jnz     dlpre
        sub     byte ptr [ebp+3],4
        sbb     byte ptr [ebp+2],0
        sbb     byte ptr [ebp+1],0
        sbb     byte ptr [ebp],0
        sub     ecx,4
dlpre:
        push    ecx
        cmp     ecx,[membase]
        jc      emudl
        cmp     ecx,[memtop]
        jc      puredl
emudl:
        mov     edx,[emuparms]
        cmp     ecx,[edx+4]
        jc      regdl
        cmp     ecx,[edx+8]
        ja      regdl
        call    emuload
        jmp     dljoin
regdl:
        cmp     ecx,offset Dregs
        jc      dljoin
        cmp     ecx,offset DregTop-4
        ja      dljoin
puredl:
        mov     eax,[ecx]
        bswap   eax
dljoin:
        pop     ecx
        cmp     dl,APOSTINC
        jnz     dlpost
        add     byte ptr [ebp+3],4
        adc     byte ptr [ebp+2],0
        adc     byte ptr [ebp+1],0
        adc     byte ptr [ebp],0
dlpost:
        ret
ldword ENDP
sztable LABEL DWORD
        dd      vnone, lbyte, lword, ldword

getValue PROC
        mov     dx,[edi + operand.xtype]
        cmp     dl,REL
        jz      gvrelimm
        cmp     dl,IMM
        jz      gvrelimm
        movzx   edx,[thesize]
        jmp    [edx * 4 + sztable]        
gvrelimm:
        mov     eax,[ecx]
vnone:
        ret
getValue ENDP

sbyte PROC
        cmp     ecx,[membase]
        jc      emubs
        cmp     ecx,[memtop]
        jc      purebs
emubs:
        mov     edx,[emuparms]
        cmp     ecx,[edx+4]
        jc      regbs
        cmp     ecx,[edx+8]
        jbe     emustore
regbs:
        cmp     ecx,offset Dregs
        jc      bsjoin
        cmp     ecx,offset DregTop-1
        ja      bsjoin
        add     ecx,3
purebs:
        mov     [ecx],al
bsjoin:
        clc
        ret
sbyte ENDP
sword PROC
        cmp     ecx,[membase]
        jc      emuws
        cmp     ecx,[memtop]
        jc      purews
emuws:
        mov     edx,[emuparms]
        cmp     ecx,[edx+4]
        jc      regws
        cmp     ecx,[edx+8]
        jbe     emustore
regws:
        cmp     ecx,offset Dregs
        jc      bwjoin
        cmp     ecx,offset DregTop-2
        ja      bwjoin
        add     ecx,2
purews:
        xchg    al,ah
        mov     [ecx],ax
bwjoin:
        clc
        ret
sword ENDP
sdword PROC
        cmp     ecx,[membase]
        jc      emuds
        cmp     ecx,[memtop]
        jc      pureds
emuds:
        mov     edx,[emuparms]
        cmp     ecx,[edx+4]
        jc      pureds
        cmp     ecx,[edx+8]
        jbe     emustore
        cmp     ecx,offset Dregs
        jc      bdjoin
        cmp     ecx,offset DregTop-4
        ja      bdjoin
pureds:
        bswap   eax
        mov     [ecx],eax
bdjoin:
        clc
        ret
sdword ENDP
sztables LABEL DWORD
        dd      vnone, sbyte, sword, sdword

storeValue PROC
        movzx   edx,[thesize]
        jmp    [edx * 4 + sztables]        
storeValue ENDP
signtab label dword
        dd      0
        dd      1,2,4,8,10h,20h,40h,80h
        dd      100h,200h,400h,800h,1000h,2000h,4000h,8000h
        dd      10000h,20000h,40000h,80000h,100000h,200000h,400000h,800000h
        dd      1000000h,2000000h,4000000h,8000000h,10000000h,20000000h,40000000h,80000000h
masktab label   dword
        dd      0
        dd      1,3,7,0fh,1fh,3fh,7fh,0ffh
        dd      1ffh,3ffh,7ffh,0fffh,1fffh,3fffh,7fffh,0ffffh
        dd      1ffffh,3ffffh,7ffffh,0fffffh,1fffffh,3fffffh,7fffffh,0ffffffh
        dd      1ffffffh,3ffffffh,7ffffffh,0fffffffh,1fffffffh,3fffffffh,7fffffffh,0ffffffffh
swaptab label byte
	db	000h,080h,040h,0c0h,020h,0a0h,060h,0e0h
	db	010h,090h,050h,0d0h,030h,0b0h,070h,0f0h
	db	008h,088h,048h,0c8h,028h,0a8h,068h,0e8h
	db	018h,098h,058h,0d8h,038h,0b8h,078h,0f8h
	db	004h,084h,044h,0c4h,024h,0a4h,064h,0e4h
	db	014h,094h,054h,0d4h,034h,0b4h,074h,0f4h
	db	00ch,08ch,04ch,0cch,02ch,0ach,06ch,0ech
	db	01ch,09ch,05ch,0dch,03ch,0bch,07ch,0fch
	db	002h,082h,042h,0c2h,022h,0a2h,062h,0e2h
	db	012h,092h,052h,0d2h,032h,0b2h,072h,0f2h
	db	00ah,08ah,04ah,0cah,02ah,0aah,06ah,0eah
	db	01ah,09ah,05ah,0dah,03ah,0bah,07ah,0fah
	db	006h,086h,046h,0c6h,026h,0a6h,066h,0e6h
	db	016h,096h,056h,0d6h,036h,0b6h,076h,0f6h
	db	00eh,08eh,04eh,0ceh,02eh,0aeh,06eh,0eeh
	db	01eh,09eh,05eh,0deh,03eh,0beh,07eh,0feh
	db	001h,081h,041h,0c1h,021h,0a1h,061h,0e1h
	db	011h,091h,051h,0d1h,031h,0b1h,071h,0f1h
	db	009h,089h,049h,0c9h,029h,0a9h,069h,0e9h
	db	019h,099h,059h,0d9h,039h,0b9h,079h,0f9h
	db	005h,085h,045h,0c5h,025h,0a5h,065h,0e5h
	db	015h,095h,055h,0d5h,035h,0b5h,075h,0f5h
	db	00dh,08dh,04dh,0cdh,02dh,0adh,06dh,0edh
	db	01dh,09dh,05dh,0ddh,03dh,0bdh,07dh,0fdh
	db	003h,083h,043h,0c3h,023h,0a3h,063h,0e3h
	db	013h,093h,053h,0d3h,033h,0b3h,073h,0f3h
	db	00bh,08bh,04bh,0cbh,02bh,0abh,06bh,0ebh
	db	01bh,09bh,05bh,0dbh,03bh,0bbh,07bh,0fbh
	db	007h,087h,047h,0c7h,027h,0a7h,067h,0e7h
	db	017h,097h,057h,0d7h,037h,0b7h,077h,0f7h
	db	00fh,08fh,04fh,0cfh,02fh,0afh,06fh,0efh
	db	01fh,09fh,05fh,0dfh,03fh,0bfh,07fh,0ffh
getbf PROC
        and     [SR],NOX_MASK
        movzx     ecx,[edi + r1]
        btr      ecx,5
        jnc     immoffs
        mov     ecx,[Dregs + 4 * ecx]
        bswap   ecx
immoffs:
        movzx   eax,[edi + r2]
        btr     eax,5
        jnc     immwidth
        mov     eax,[Dregs + 4 * eax]
        bswap   eax
immwidth:
        and     eax,31
        jnz     immwidth2
        bts     eax,5
immwidth2:
        cmp     [edx + xtype],REGN
        jnz     okwidth
        mov     ebp,32
        sub     ebp,ecx
        cmp     eax,ebp
        jl      okwidth
        mov     eax,ebp
        jmp     okwidth
nomask:
        sub     eax,eax
        sub     ecx,ecx
okwidth:
        push    ebx
        push    eax
        push    ecx
        mov     edi,edx
        call    getAddress
        mov     edx,ecx
        pop     ecx
        push    ecx
        sar     ecx,3
        add     edx,ecx
        mov     ebx,offset swaptab
        mov     al,byte ptr [edx+4]
        xlat
        mov     edx,[edx]
        xchg    eax,edx
        xlat
        rol     eax,8
        xlat
        rol     eax,8
        xlat
        rol     eax,8
        xlat
        rol     eax,8
        pop     ecx
        mov     ebp,ecx
        and     ecx,7
        shrd    eax,edx,cl
        pop     edx
        mov     ebx,[masktab + 4 * edx]
        test    ebx,eax
        jnz     signnz
        bts     [SR],Z_BIT
signnz:
        test    eax,[signtab + 4 * edx]
        jz      signns
        bts     [SR],N_BIT
        mov     ebx,[masktab + 4 * edx]
        not     ebx
        or      eax,ebx
signns:
        mov     ecx,ebp
        pop     ebx
        ret
getbf ENDP
storebf PROC
        push    ebx
        push    eax
        movzx     ecx,[edi + r1]
        btr      ecx,5
        jnc     simmoffs
        mov     ecx,[Dregs + 4 * ecx]
        bswap   ecx
simmoffs:
        movzx   eax,[edi + r2]
        btr     eax,5
        jnc     simmwidth
        mov     eax,[Dregs + 4 * eax]
        bswap   eax
simmwidth:
        and     eax,31
        jnz     simmwidth2
        bts     eax,5
simmwidth2:
        cmp     [edx + xtype],REGN
        jnz     sokwidth
        mov     ebp,32
        sub     ebp,ecx
        cmp     eax,ebp
        jl      sokwidth
        mov     eax,ebp
        jmp     sokwidth
snomask:
        sub     eax,eax
        sub     ecx,ecx
sokwidth:
        push    eax
        push    ecx
        mov     edi,edx
        call    getAddress
        mov     edx,ecx
        pop     ecx
        pop     ebp
        push    ecx
        sar     ecx,3
        add     edx,ecx
        pop     ecx
        and     ecx,7
        mov     eax,[ebp*4 + masktab]
        sub     ebx,ebx
        shld    ebx,eax,cl
        shl     eax,cl
        not     eax
        not     bl
        mov     bl,[swaptab+ebx]
        push    ebx
        mov     ebx,offset swaptab
        xlatb
        rol     eax,8
        xlatb
        rol     eax,8
        xlatb
        rol     eax,8
        xlatb
        rol     eax,8
        pop     ebx
        and     [edx],eax
        and     [edx+4],bl
        sub     ebx,ebx
        pop     eax
        shld    ebx,eax,cl
        shl     eax,cl
        mov     bl,[swaptab + ebx]
        push    ebx
        mov     ebx,offset swaptab
        xlatb
        rol     eax,8
        xlatb
        rol     eax,8
        xlatb
        rol     eax,8
        xlatb
        rol     eax,8
        pop     ebx
        or      [edx],eax
        or      [edx+4],bl
        pop     ebx
        ret
storebf ENDP
changesr PROC
        and     [SR],INVALID_SR_BITS
        mov     ax,[oldsr]
        mov     dx,word ptr [SR+2]
        test    [prm_00],1
        jz      csr_020
        btr     [SR],TRACE_BIT2
        btr     [SR],MASTER_BIT
csr_020:
        mov     ecx,eax
        xor     ecx,edx
        and     ecx,30h
        jz      nostackchange

        mov     ecx,[Dregs + 15 * 4]
        test    dl,20h
        jz      notstoreusp
        mov     [USP],ecx
        jmp     nostorestack
notstoreusp:
        test    al,10h
        jz      storeisp
        mov     [MSP],ecx
        jmp     nostorestack
storeisp:
        mov     [ISP],ecx
nostorestack:
        test    dl,20h
        jnz     notusp
        mov     eax,[USP]
        jmp     finchange
notusp:
        mov     eax,[MSP]
        test    dl,10h
        jnz     finchange
        mov     eax,[ISP]
finchange:
        mov     [Dregs + 15 * 4],eax
nostackchange:        
        mov     [oldsr],dx
        ret
changesr ENDP
illoptrap PROC
        mov     al,4
        mov     esi,[oldpc]
        jmp     taketrap
illoptrap ENDP
supervtrap PROC
        mov     al,8
        mov     esi,[oldpc]
supervtrap ENDP
taketrap PROC
        test    [hasvects],1
        jz      badtrap
        mov     bp,word ptr [SR + 2]
        bts     [SR],SUPERV_BIT
        btr     [SR],TRACE_BIT
        btr     [SR],TRACE_BIT2
        push    eax
        call    changesr
        pop     eax
        movzx   eax,ax
        shl     eax,2
        mov     edx,[membase]
        mov     edi,[Dregs + 15 * 4]
        bswap   edi
        mov     ecx,eax
        and     ecx,3ffh
        sub     edi,6
        test    [prm_00],1
        jne     trap00
        sub     edi,2
        test    ax,2000h
        jz      notextended
        sub     edi,4
        push    eax
        mov     eax,[oldpc]
        sub     eax,edx
        bswap   eax
        mov     [edi+edx+8],eax
        pop     eax
notextended:
        xchg    al,ah
        mov     [edi + edx + 6],ax
trap00:
        mov     eax,esi
        sub     eax,edx
        bswap   eax
        mov     [edi + edx + 2],eax
        mov     [edi + edx],bp
        bswap   edi
        mov     [Dregs + 15 * 4],edi
        add     ecx,edx
        mov     eax,[VBR]       ; will not change if in 000 mode
        bswap   eax
        add     ecx,eax
        mov     esi,[ecx]
        bswap   esi
        add     esi,edx
        clc
        ret
badtrap:
        mov     [badtrapnum],al
        stc
        ret
taketrap ENDP
i_movep PROC
        mov     edi,offset dbg_op1
        call    getAddress
        call    getValue
        push    eax
        mov     edi,offset dbg_op2
        call    getAddress
        pop     eax
        mov     dl,SZ_BYTE
        xchg    dl,[thesize]
        cmp     dl,SZ_LONG
        jnz     movep_w
        push    eax
        shr     eax,16
        push    eax
        xchg    al,ah
        call    storeValue
        add     ecx,2
        pop     eax
        call    storeValue
        add     ecx,2
        pop     eax
movep_w:
        push    eax
        xchg    al,ah
        call    storeValue
        add     ecx,2
        pop     eax
        call    storeValue
	ret
i_movep ENDP
i_btst PROC
        mov     [thesize],SZ_BYTE
        cmp     [edi + operand.xtype],REGN
        jnz     btb
        mov     [thesize],SZ_LONG
btb:
        btr     [SR],Z_BIT
        mov     edi,offset dbg_op1
        call    getAddress
        call    getValue
        push    eax
        mov     edi,offset dbg_op2
        call    getAddress
        call    getValue
        pop     edx
        cmp     [edi + operand.xtype],REGN
        jz      btno8mod
        and     edx,7
btno8mod:
        bt      eax,edx
        jc      btnoset
        bts     [SR],Z_BIT
btnoset:
        clc
	ret
i_btst ENDP
i_bchg PROC
        call    i_btst
        btc     eax,edx
        jmp     storeValue
i_bchg ENDP
i_bclr PROC
        call    i_btst
        btr     eax,edx
        jmp    storeValue
i_bclr ENDP
i_bset PROC
        call    i_btst
        bts     eax,edx
        jmp    storeValue
i_bset ENDP
i_rtm PROC
        ; exit if 00
;        inc     [changeofflow]
        stc
	ret
i_rtm ENDP
i_callm PROC
        ; exit if 000
;        inc     [changeofflow]
        stc
	ret
i_callm ENDP
i_cas2 PROC
        ; exit if 00
        stc
	ret
i_cas2 ENDP
i_cas PROC
        test    [prm_00],1
        jnz     illoptrap
        mov     edi,offset dbg_op1
        call    getAddress
        call    getValue
        push    eax
        mov     edi,offset dbg_op3
        call    getAddress
        call    getValue
        pop     edx
        and     [SR],NOF_MASK
        movzx   edi,[thesize]
        jmp     [castab + edi*4]
castab label dword
        dd      casword,casbyte,casword,caslong
casbyte:
        cmp     al,dl
        jmp     cascont
casword:
        cmp     ax,dx
        jmp     cascont
caslong:
        cmp     eax,edx
cascont:
        jnc     casnocy
        bts     [SR],C_BIT
        bts     [SR],X_BIT
casnocy:
        jno     casnoov
        bts     [SR],V_BIT
casnoov:
        jns     casnosign
        bts     [SR],N_BIT
casnosign:
        jnz     casnoz
        bts     [SR],Z_BIT
        push    ecx
        mov     edi,offset dbg_op2
        call    getAddress      
        call    getValue
        pop     ecx
        
        jmp     storeValue
casnoz:
        push    eax
        mov     edi,offset dbg_op1
        call    getAddress
        pop     eax
        jmp     storeValue
i_cas ENDP
i_cmpchk PROC
        test    [prm_00],1
        jnz     illoptrap
        btr     [SR],C_BIT
        btr     [SR],Z_BIT
        mov     edi,offset dbg_op1
        call    getAddress
        movzx   edx,[thesize]
        jmp     [cmpchktab + edx * 4]
cmpchktab label dword
        dd      cmpchkword,cmpchkbyte,cmpchkword,cmpchkdword
cmpchkbyte:
        movsx   edx,byte ptr [ecx]
        movsx   ecx,byte ptr [ecx+1]
        jmp     cmpchkjoin
cmpchkword:
        mov     dx,[ecx]
        mov     cx,[ecx+2]
        xchg    dl,dh
        xchg    cl,ch
        movsx   edx,dx
        movsx   ecx,cx
        jmp     cmpchkjoin
cmpchkdword:
        mov     edx,[ecx]
        mov     ecx,[ecx+4]
        bswap   edx
        bswap   ecx
cmpchkjoin:
        movzx   eax,[dbg_op2.r1]
        bt      eax,3
        mov     eax,[eax*4 + Dregs]
        bswap   eax
        jc      cmpchkdword2
        movzx   ebp,[thesize]
        jmp     [cmpchktab2 + ebp * 4]
cmpchktab2 label dword
        dd      cmpchkword2,cmpchkbyte2,cmpchkword2,cmpchkdword2
cmpchkbyte2:
        cmp     al,dl
        jz      zero
        jl      obounds
        cmp     al,cl
        jz      zero
        jg      obounds
        clc
        ret
cmpchkword2:
        cmp     ax,dx
        jz      zero
        jl      obounds
        cmp     ax,cx
        jz      zero
        jg      obounds
        clc
        ret
cmpchkdword2:
        cmp     eax,edx
        jz      zero
        jl      obounds
        cmp     eax,ecx
        jz      zero
        jg      obounds
        clc
        ret
zero:
        bts     [SR],Z_BIT
        ret
obounds:
        bts     [SR],C_BIT
        mov     eax,[oldpc]
        bt      word ptr [eax + 2],3
        jnc     ccnt
        mov     ax,806h
        jmp     taketrap
ccnt:
        ret


i_cmpchk ENDP
i_orccr PROC
        mov     al,byte ptr [dbg_op1.bd]
        and     al,INVALID_CCR_BITS
        or      byte ptr [SR+3],al
	ret
i_orccr ENDP
i_orsr PROC
        bt      [SR],SUPERV_BIT
        jnc     supervtrap
        mov     ax,word ptr [dbg_op1.bd]
        xchg    al,ah
        or      word ptr [SR+2],ax      
        jmp     changesr
i_orsr ENDP
i_or PROC
        mov     edi,offset dbg_op1
        call    getAddress
        call    getValue
        push    eax
        mov     edi,offset dbg_op2
        call    getAddress
        call    getValue
        pop     edx
        and     [SR],NOX_MASK
        movzx   edi,[thesize]
        jmp     [ortab + edi*4]
ortab label dword
        dd      orword,orbyte,orword,orlong
orbyte:
        or      al,dl
        jmp     orcont
orword:
        or      ax,dx
        jmp     orcont
orlong:
        or      eax,edx
orcont:
        jns     ornosign
        bts     [SR],N_BIT
ornosign:
        jnz     ornoz
        bts     [SR],Z_BIT
ornoz:
        jmp     storeValue
i_or ENDP
i_andccr PROC
        mov     al,byte ptr [dbg_op1.bd]
        and     al,INVALID_CCR_BITS
        and     byte ptr [SR+3],al
	ret
i_andccr ENDP
i_andsr PROC
        bt      [SR],SUPERV_BIT
        jnc     supervtrap
        mov     ax,word ptr [dbg_op1.bd]
        xchg    al,ah
        and     word ptr [SR+2],ax      
        jmp     changesr
i_andsr ENDP
i_and PROC
        mov     edi,offset dbg_op1
        call    getAddress
        call    getValue
        push    eax
        mov     edi,offset dbg_op2
        call    getAddress
        call    getValue
        pop     edx
        and     [SR],NOX_MASK
        movzx   edi,[thesize]
        jmp     [andtab + edi*4]
andtab  label   dword
        dd      andword,andbyte,andword,andlong
andbyte:
        and     al,dl
        jmp     andcont
andword:
        and     ax,dx
        jmp     andcont
andlong:
        and     eax,edx
andcont:
        jns     andnosign
        bts     [SR],N_BIT
andnosign:
        jnz     andnoz
        bts     [SR],Z_BIT
andnoz:
        jmp     storeValue
i_and ENDP
i_sub PROC
        mov     edi,offset dbg_op1
        call    getAddress
        call    getValue
        push    eax
        mov     edi,offset dbg_op2
        call    getAddress
        call    getValue
        pop     edx
        and     [SR],NOF_MASK
        movzx   edi,[thesize]
        jmp     [subtab + edi*4]
subtab  label   dword
        dd      subword,subbyte,subword,sublong
subbyte:
        sub     al,dl
        jmp     subcont
subword:
        sub     ax,dx
        jmp     subcont
sublong:
        sub     eax,edx
subcont:
        jnc     subnocy
        bts     [SR],C_BIT
        bts     [SR],X_BIT
subnocy:
        jno     subnoov
        bts     [SR],V_BIT
subnoov:
        jns     subnosign
        bts     [SR],N_BIT
subnosign:
        jnz     subnoz
        bts     [SR],Z_BIT
subnoz:
        jmp     storeValue
i_sub ENDP
i_add PROC
        mov     edi,offset dbg_op1
        call    getAddress
        call    getValue
        push    eax
        mov     edi,offset dbg_op2
        call    getAddress
        call    getValue
        pop     edx
        and     [SR],NOF_MASK
        movzx   edi,[thesize]
        jmp     [addtab + edi*4]
addtab  label   dword
        dd      addword,addbyte,addword,addlong
addbyte:
        add     al,dl
        jmp     addcont
addword:
        add     ax,dx
        jmp     addcont
addlong:
        add     eax,edx
addcont:
        jnc     addnocy
        bts     [SR],C_BIT
        bts     [SR],X_BIT
addnocy:
        jno     addnoov
        bts     [SR],V_BIT
addnoov:
        jns     addnosign
        bts     [SR],N_BIT
addnosign:
        jnz     addnoz
        bts     [SR],Z_BIT
addnoz:
        jmp     storeValue
i_add ENDP
i_eorccr PROC
        mov     al,byte ptr [dbg_op1.bd]
        and     al,INVALID_CCR_BITS
        xor     byte ptr [SR+3],al
	ret
i_eorccr ENDP
i_eorsr PROC
        bt      [SR],SUPERV_BIT
        jnc     supervtrap
        mov     ax,word ptr [dbg_op1.bd]
        xchg    al,ah
        xor     word ptr [SR+2],ax      
        jmp     changesr
i_eorsr ENDP
i_eor PROC
        mov     edi,offset dbg_op1
        call    getAddress
        call    getValue
        push    eax
        mov     edi,offset dbg_op2
        call    getAddress
        call    getValue
        pop     edx
        and     [SR],NOX_MASK
        movzx   edi,[thesize]
        jmp     [eortab + edi*4]
eortab  label   dword
        dd      eorword,eorbyte,eorword,eorlong
eorbyte:
        xor     al,dl
        jmp     eorcont
eorword:
        xor     ax,dx
        jmp     eorcont
eorlong:
        xor     eax,edx
eorcont:
        jns     eornosign
        bts     [SR],N_BIT
eornosign:
        jnz     eornoz
        bts     [SR],Z_BIT
eornoz:
        jmp     storeValue
	ret
i_eor ENDP
i_cmp PROC
        mov     edi,offset dbg_op1
        call    getAddress
        call    getValue
        push    eax
        mov     edi,offset dbg_op2
        call    getAddress
        call    getValue
        pop     edx
        and     [SR],NOF_MASK
        movzx   edi,[thesize]
        jmp     [cmptab + edi*4]
cmptab  label   dword
        dd      cmpword,cmpbyte,cmpword,cmplong
cmpbyte:
        cmp     al,dl
        jmp     cmpcont
cmpword:
        cmp     ax,dx
        jmp     cmpcont
cmplong:
        cmp     eax,edx
cmpcont:
        jnc     cmpnocy
        bts     [SR],C_BIT
        bts     [SR],X_BIT
cmpnocy:
        jno     cmpnoov
        bts     [SR],V_BIT
cmpnoov:
        jns     cmpnosign
        bts     [SR],N_BIT
cmpnosign:
        jnz     cmpnoz
        bts     [SR],Z_BIT
cmpnoz:
        clc
        ret
i_cmp ENDP
i_moves PROC
        test    [prm_00],1
        jnz     illoptrap
        bt      [SR],SUPERV_BIT
        jnc     supervtrap
        jmp     i_move  ; not supporting seperate address space
i_moves ENDP
i_movea PROC
        mov     edi,offset dbg_op1
        call    getAddress
        call    getValue
        push    eax
        mov     edi,offset dbg_op2
        call    getAddress
        pop     eax
        cmp     [thesize],SZ_LONG
        jz      storeValue
        mov     [thesize],SZ_LONG
        movsx   eax,ax
        jmp     storeValue
i_movea ENDP
i_moveq PROC
        mov     [thesize],SZ_LONG
i_moveq ENDP
i_move PROC
        mov     edi,offset dbg_op1
        call    getAddress
        call    getValue
        push    eax
        mov     edi,offset dbg_op2
        call    getAddress
        pop     eax
        and     [SR],NOX_MASK
        movzx   edi,[thesize]
        jmp     [movetab + edi*4]
movetab label   dword
        dd      moveword,movebyte,moveword,movelong
movebyte:
        cmp     [dbg_op2.xtype],APREDEC
        jnz     mbnpd
        sub     byte ptr [ebp+3],1
        sbb     byte ptr [ebp+2],0
        sbb     byte ptr [ebp+1],0
        sbb     byte ptr [ebp+0],0
        dec     ecx
mbnpd:
        cmp     [dbg_op2.xtype],APOSTINC
        jnz     mbnpi
        add     byte ptr [ebp + 3],1
        adc     byte ptr [ebp + 2],0
        adc     byte ptr [ebp + 1],0
        adc     byte ptr [ebp + 0],0
mbnpi:
        or      al,al
        jmp     movecont
moveword:
        cmp     [dbg_op2.xtype],APREDEC
        jnz     mwnpd
        sub     byte ptr [ebp+3],2
        sbb     byte ptr [ebp+2],0
        sbb     byte ptr [ebp+1],0
        sbb     byte ptr [ebp+0],0
        dec     ecx
        dec     ecx
mwnpd:
        cmp     [dbg_op2.xtype],APOSTINC
        jnz     mwnpi
        add     byte ptr [ebp + 3],2
        adc     byte ptr [ebp + 2],0
        adc     byte ptr [ebp + 1],0
        adc     byte ptr [ebp + 0],0
mwnpi:
        or      ax,ax
        jmp     movecont
movelong:
        cmp     [dbg_op2.xtype],APREDEC
        jnz     mlnpd
        sub     byte ptr [ebp+3],4
        sbb     byte ptr [ebp+2],0
        sbb     byte ptr [ebp+1],0
        sbb     byte ptr [ebp+0],0
        sub     ecx,4
mlnpd:
        cmp     [dbg_op2.xtype],APOSTINC
        jnz     mlnpi
        add     byte ptr [ebp + 3],4
        adc     byte ptr [ebp + 2],0
        adc     byte ptr [ebp + 1],0
        adc     byte ptr [ebp + 0],0
mlnpi:
        or      eax,eax
movecont:
        jns     movenosign
        bts     [SR],N_BIT
movenosign:
        jnz     movenoz
        bts     [SR],Z_BIT
movenoz:
        jmp     storeValue
i_move ENDP
i_extb PROC
        mov     edi,offset dbg_op1
        call    getAddress
        call    getValue
        and     [SR],NOX_MASK
        movsx   eax,al
        or      eax,eax
        jns     extbnosign
        bts     [SR],N_BIT
extbnosign:
        jnz     extbnoz
        bts     [SR],Z_BIT
extbnoz:
        jmp     storeValue
i_extb ENDP
i_lea PROC
        mov     edi,offset dbg_op1
        call    getAddress
        push    ecx
        mov     edi,offset dbg_op2
        call    getAddress
        pop     eax
        sub     eax,[membase]
        jmp     storeValue
i_lea ENDP
i_chk PROC
        mov     edi,offset dbg_op1
        call    getAddress
        call    getValue
        push    eax
        mov     edi,offset dbg_op2
        call    getAddress
        call    getValue
        pop     edx
        cmp     [thesize],SZ_LONG
        jz      chklong
        movsx   eax,ax
        movsx   edx,dx
chklong:
        or      eax,eax
        jns     nlz
        bts     [SR],N_BIT
        mov     ax,806h
        jmp     taketrap
nlz:
        cmp     eax,edx
        jle     chkret
        btr     [SR],N_BIT
        mov     ax,806h
        jmp     taketrap
chkret:
        clc
	ret
i_chk ENDP
i_movesr PROC
        mov     [thesize],SZ_WORD
        cmp     [dbg_op1.xtype],REGN
        jnz     tosr
        cmp     [dbg_op1.r1],RG_SR
        jnz     tosr
        mov     edi,offset dbg_op2
        call    getAddress
        mov     ax,word ptr [SR+2]
        xchg    al,ah
        jmp     storeValue
tosr:
        bt      [SR],SUPERV_BIT
        jnc     supervtrap
        mov     edi,offset dbg_op1
        call    getAddress
        call    getValue
        xchg    al,ah
        mov     word ptr [SR+2],ax
        jmp     changesr
i_movesr ENDP
i_negx PROC
        mov     edi,offset dbg_op1
        call    getAddress
        call    getValue
        sub     edx,edx
        btr     [SR],C_BIT
        btr     [SR],X_BIT
        movzx   edi,[thesize]
        jmp     [negextab + edi*4]
negextab label dword
        dd      negexword,negexbyte,negexword,negexlong
negexbyte:
        sbb     dl,al
        jmp     negexcont
negexword:
        sbb     dx,ax
        jmp     negexcont
negexlong:
        sbb     edx,eax
negexcont:
        jno     negexnoov
        bts     [SR],V_BIT
negexnoov:
        jns     negexnosign
        bts     [SR],N_BIT
negexnosign:
        jnz     negexnoz
        bts     [SR],Z_BIT
        jmp     negexzd
negexnoz:
        bts     [SR],C_BIT
        bts     [SR],X_BIT
negexzd:
        mov     eax,edx
        jmp     storeValue
i_negx ENDP
i_moveccr PROC
        mov     [thesize],SZ_BYTE
        cmp     [dbg_op1.xtype],REGN
        jnz     toccr
        cmp     [dbg_op1.r1],RG_CCR
        jnz     toccr
        mov     edi,offset dbg_op2
        call    getAddress
        mov     al,byte ptr [SR+3]
        xchg    al,ah
        jmp     storeValue
toccr:
        mov     edi,offset dbg_op1
        call    getAddress
        call    getValue
        and     al,INVALID_CCR_BITS
        mov     byte ptr [SR+3],al
	ret
i_moveccr ENDP
i_clr PROC
        and     [SR],NOX_MASK
        bts     [SR],Z_BIT
        mov     edi,offset dbg_op1
        call    getAddress
        test    [prm_00],1      ; 68000 does a RMW
        jz      clr_n00
        call    getValue
clr_n00:
        sub     eax,eax
        jmp     storeValue
i_clr ENDP
i_neg PROC
        mov     edi,offset dbg_op1
        call    getAddress
        call    getValue
        sub     edx,edx
        and     [SR],NOF_MASK
        movzx   edi,[thesize]
        jmp     [negtab + edi*4]
negtab  label   dword
        dd      negword,negbyte,negword,neglong
negbyte:
        sbb     dl,al
        jmp     negcont
negword:
        sbb     dx,ax
        jmp     negcont
neglong:
        sbb     edx,eax
negcont:
        jno     negnoov
        bts     [SR],V_BIT
negnoov:
        jns     negnosign
        bts     [SR],N_BIT
negnosign:
        jnz     negnoz
        bts     [SR],Z_BIT
        jmp     negzd
negnoz:
        bts     [SR],C_BIT
        bts     [SR],X_BIT
negzd:
        mov     eax,edx
        jmp     storeValue
i_neg ENDP
i_not PROC
        mov     edi,offset dbg_op1
        call    getAddress
        call    getValue
        and     [SR],NOX_MASK
        movzx   edi,[thesize]
        jmp     [nottab + edi*4]
nottab  label   dword
        dd      notword,notbyte,notword,notlong
notbyte:
        not     al
        or      al,al
        jmp     notcont
notword:
        not     ax
        or      ax,ax
        jmp     notcont
notlong:
        not     eax
        or      eax,eax
notcont:
        jns     notnosign
        bts     [SR],N_BIT
notnosign:
        jnz     notnoz
        bts     [SR],Z_BIT
notnoz:
        jmp     storeValue
i_not ENDP
i_ext PROC
        mov     edi,offset dbg_op1
        call    getAddress
        call    getValue
        and     [SR],NOX_MASK
        cmp     [thesize],SZ_LONG
        jz      extlong
        movsx   ax,al
        or      ax,ax
        jmp     extcont
extlong:
        movsx   eax,ax
        or      eax,eax
extcont:
        jns     extnosign
        bts     [SR],N_BIT
extnosign:
        jnz     notnoz
        bts     [SR],Z_BIT
extnoz:
        jmp     storeValue
i_ext ENDP
i_lnk PROC
        cmp     [thesize],SZ_LONG
        jnz     lnkok
        test    [prm_00],1
        jnz     illoptrap
lnkok:
        mov     al,[thesize]
        push    eax
        mov     [thesize],SZ_LONG
        mov     edi,offset dbg_op1
        call    getAddress
        call    getValue
        mov     ebp,[Dregs + 15 * 4]
        bswap   ebp
        sub     ebp,4
        bswap   ebp
        mov     [ecx],ebp
        bswap   ebp
        add     ebp,[membase]
        bswap   eax
        mov     [ebp],eax
        mov     eax,dword ptr [dbg_op2 + operand.bd]
        pop     edx
        cmp     dl,SZ_LONG
        jz      lnknowrd
        movsx   eax,ax
lnknowrd:
        add     ebp,eax
        sub     ebp,[membase]
        bswap   ebp
        mov     [Dregs + 15 * 4],ebp
	ret
i_lnk ENDP
i_nbcd PROC
        mov     [thesize],SZ_BYTE
        mov     edi,offset dbg_op1
        call    getAddress
        call    getValue
        xchg    al,dl
        sub     al,al
        btr     [SR],C_BIT
        btr     [SR],X_BIT
        sbb     al,dl
        das
        jnc     nbcdnc
        bts     [SR],C_BIT
        bts     [SR],X_BIT
nbcdnc:
        jz      nbcdnz
        btr     [SR],Z_BIT
nbcdnz:
        jmp     storeValue      
i_nbcd ENDP
i_swap PROC
        mov     [thesize],SZ_LONG
        mov     edi,offset dbg_op1
        and     [SR],NOX_MASK
        call    getAddress
        call    getValue
        mov     edx,eax
        shr     edx,16
        shl     eax,16
        or      eax,edx
        jnz     isw_nz
        bts     [SR],Z_BIT
isw_nz:
        jns     isw_ns
        bts     [SR],N_BIT
isw_ns:
        jmp     storeValue
i_swap ENDP
i_bkpt PROC
        jmp     illoptrap
i_bkpt ENDP
i_pea PROC
        mov     edi,offset dbg_op1
        call    getAddress
        sub     ecx,[membase]
        bswap   ecx
        mov     edx,[Dregs + 15 * 4]
        bswap   edx
        add     edx,[membase]
        sub     edx,4
        mov     [edx],ecx
        sub     edx,[membase]
        bswap   edx
        mov     [Dregs +15*4],edx
        clc
        ret
i_pea ENDP
i_movem PROC
        push    esi
        cmp     [dbg_op1.xtype],NMOVEM
        jz      movemfrom
        mov     edi,offset dbg_op1
        call    getAddress
        push    ebp
        push    ecx
        mov     esi,ecx
        movzx     ebp,word ptr [dbg_op2.r1]
        mov     ecx,-4
mmtlp:
        or      bp,bp
        jz      mmtx
        add     ecx,4
        shr     bp,1
        jnc     mmtlp
        cmp     [thesize],SZ_LONG
        jz      mmllong
        lodsw
        mov     word ptr [Dregs + ecx+2],ax
        jmp     mmtlp
mmllong:
        lodsd
        mov     [Dregs + ecx],eax
        jmp     mmtlp
mmtx:
        pop     ecx
        pop     ebp
        cmp     [dbg_op1.xtype],APOSTINC
        jnz     movemret
        mov     eax,esi
        sub     eax,[membase]
        bswap   eax
        mov     [ebp],eax
movemret:
        clc     
        pop     esi
        ret
movemfrom:                  
        mov     edi,offset dbg_op2
        call    getAddress
        cmp     [dbg_op2.xtype],APREDEC
        jnz     mmfok
        sub     edx,edx
        mov     eax,2
        cmp     [thesize],SZ_LONG
        jnz     mmpdnl
        shl     eax,1
mmpdnl:
        movzx     edi,word ptr [dbg_op1.r1]
mmpdc:
        or      di,di
        jz      mmpdd
        shr     di,1
        jnc     mmpdc
        add     edx,eax
        jmp     mmpdc
mmpdd:
        sub     ecx,edx
        mov     eax,ecx
        sub     eax,[membase]
        bswap   eax
        mov     [ebp],eax
mmfok:
        mov     edi,ecx
        movzx     ebp,word ptr [dbg_op1.r1]
        mov     ecx,-4
mmflp:
        or      bp,bp
        jz      movemret
        add     ecx,4
        shr     bp,1
        jnc     mmflp
        cmp     [thesize],SZ_LONG
        jz      mmflong
        mov     ax,word ptr [Dregs + ecx + 2]
        stosw
        jmp     mmflp
mmflong:
        mov     eax,[Dregs + ecx]
        stosd
        jmp     mmflp
i_movem ENDP
i_illegal PROC
        jmp     illoptrap
i_illegal ENDP
i_tas PROC
        mov     [thesize],SZ_BYTE
        mov     edi,offset dbg_op1
        call    getAddress
        call    getValue
        and     [SR],NOX_MASK
        or      al,al
        jns     tasns
        bts     [SR],N_BIT
tasns:
        jnz     tasnz
        bts     [SR],Z_BIT
tasnz:
        or      al,80h
        jmp     storeValue
i_tas ENDP
i_tst PROC
        mov     edi,offset dbg_op1
        call    getAddress
        call    getValue
        and     [SR],NOX_MASK
        movzx   edi,[thesize]
        jmp     [tsttab + edi*4]
tsttab  label   dword
        dd      tstword,tstbyte,tstword,tstlong
tstbyte:
        or      al,al
        jmp     tstcont
tstword:
        or      ax,ax
        jmp     tstcont
tstlong:
        or      eax,eax
tstcont:
        jns     tstnosign
        bts     [SR],N_BIT
tstnosign:
        jnz     tstnoz
        bts     [SR],Z_BIT
tstnoz:
        ret
i_tst ENDP
i_lmul PROC
        test    [prm_00],1
        jnz     illoptrap
        mov     edi,offset dbg_op1
        call    getAddress
        call    getValue
        and     [SR],NOX_MASK
        mov     edi,[oldpc]
        movzx   edi,word ptr [edi+2]
        mov     ecx,edi
        shr     ecx,12-8
        and     ecx,7
        lea     ecx,[Dregs + 4 * ecx]
        mov     edx,[ecx]
        bswap   edx
        bt      edi,11-8
        jc      lmul_signed
        mul     edx
        jmp     lmul_end
lmul_signed:
        imul    edx
lmul_end:
        bt      edx,31
        jnc     lmulnoneg
        bts     [SR],N_BIT
lmulnoneg:
        mov     ebp,edx
        or      ebp,eax
        jnz     lmulnoz
        bts     [SR],Z_BIT
lmulnoz:
        bswap   eax
        mov     [ecx],eax
        bt      edi,10-8
        jnc     lmulchkov
        mov     ebp,edi
        shr     ebp,8
        and     ebp,7
        bswap   edx
        mov     [Dregs + 4 * ebp],edx
        clc
        ret
lmulchkov:
        bt      edi,11-8
        jc      lmul_signed2
        or      edx,edx
        jnz     lmulov
        clc
        ret
lmul_signed2:
        bt      eax,31-24 ; bytes swapped
        jnc     lmulsicmp
        inc     edx
        jnz     lmulov
        clc
        ret
lmulsicmp:
        or      edx,edx
        jz      lmulnoov
lmulov:
        bts     [SR],V_BIT
lmulnoov:
        clc
	ret
i_lmul ENDP
i_ldiv PROC
        test    [prm_00],1
        jnz     illoptrap
        mov     edi,offset dbg_op1
        call    getAddress
        call    getValue
        or      eax,eax
        jz      divbyzero
        and     [SR],NOX_MASK
        mov     edi,[oldpc]
        movzx   edi,word ptr [edi+2]
        mov     ecx,edi
        shr     ecx,12-8
        and     ecx,15
        lea     ecx,[Dregs + 4 * ecx]
        mov     ebp,[ecx]
        bswap   ebp
        xchg    eax,ebp
        cdq
        bt      edi,11-8
        jc      ldiv_s1
        sub     edx,edx
ldiv_s1:

        bt      edi,10-8
        jnc     nolldiv
        mov     edx,edi
        shr     edx,8
        and     edx,7
        mov     edx,[Dregs + 4 * edx]
        bswap   edx
nolldiv:
        bt      edi,11-8
        jc      ldiv_signed
        cmp     edx,ebp
        jae     div_ov
        div     ebp
        jmp     ldiv_end
ldiv_signed:
        push    edx
        push    eax
        push    ebp
        or      edx,edx
        jns     ldivna1
        neg     edx
        neg     eax
        sbb     edx,0
ldivna1:
        or      ebp,ebp
        jns     ldivna2
        neg     ebp
ldivna2:
        shld    edx,eax,1
        cmp     edx,ebp
        pop     ebp
        pop     eax
        pop     edx
        jae     div_ov
        idiv    ebp
ldiv_end:
        bt      eax,32
        jnc     ldivnoneg
        bts     [SR],N_BIT
ldivnoneg:
        or      eax,eax
        jnz     ldivnoz
        bts     [SR],Z_BIT
ldivnoz:
        bswap   eax
        mov     [ecx],eax
        mov     ebp,edi
        shr     ebp,8
        and     ebp,7
        lea     ebp,[Dregs + 4 * ebp]
        cmp     ebp,ecx
        jz      ldivdn
        bswap   edx
        mov     [ebp],edx
ldivdn:
        clc
        ret
div_ov:
        bts     [SR],V_BIT
        clc
        ret
divbyzero:
        mov     ax,805h
        jmp     taketrap
i_ldiv ENDP
i_trap PROC
        mov     al,byte ptr [dbg_op1.bd]
        add     al,32
        jmp     taketrap
i_trap ENDP
i_link PROC
        jmp     i_lnk
i_link ENDP
i_unlk PROC
        mov     [thesize],SZ_LONG
        mov     edi,offset dbg_op1
        call    getAddress
        call    getValue
        mov     ebp,eax
        add     eax,[membase]
        mov     eax,[eax]
        mov     [ecx],eax
        add     ebp,4
        bswap   ebp
        mov     [Dregs + 15 * 4],ebp
        clc
        ret
i_unlk ENDP
i_moveusp PROC
        test    [prm_00],1
        jnz     illoptrap
        bt      [SR],SUPERV_BIT
        jnc      supervtrap
        cmp     [dbg_op1.r1],16
        jge     fromusp
        
        movzx   eax,[dbg_op1.r1]
        mov     eax,[eax * 4 + Dregs]
        mov     [USP],eax
        clc
        ret
fromusp:
        mov     eax,[USP]
        movzx   edx,[dbg_op2.r1]
        mov     [edx * 4 + Dregs],eax
        clc
	ret
i_moveusp ENDP
i_reset PROC
        bt      [SR],SUPERV_BIT
        jnc     supervtrap
        clc
	ret
i_reset ENDP
i_nop PROC
        clc
	ret
i_nop ENDP
i_stop PROC
        bt      [SR],SUPERV_BIT
        jnc     supervtrap
        mov     eax,[dbg_op1.bd]
        bswap   eax
        mov     [SR],eax
        inc     [stopped]
        stc
	ret
i_stop ENDP
i_rte PROC
        bt      [SR],SUPERV_BIT
        jnc     supervtrap
        mov     ecx,[Dregs + 15 * 4]
        bswap   ecx
        mov     edx,[membase]
        mov     ax,[ecx + edx]
        mov     word ptr [SR+2],ax
        mov     esi,[ecx + 2 + edx]
        bswap   esi
        add     esi,edx
        add     ecx,6
        test    [prm_00],1
        jnz     rte_00
        mov     ax,[ecx + edx]
        add     ecx,2
        test    ax,2000h
        jz      rte_00
        add     ecx,4
rte_00:
        bswap   ecx
        mov     [Dregs + 15 * 4],ecx
        inc     [changeofflow]
        jmp     changesr
i_rte ENDP
i_rtd PROC
        mov     ecx,[Dregs + 15 * 4]
        bswap   ecx
        mov     edx,[membase]
        mov     esi,[ecx + edx]
        bswap   esi
        add     esi,[membase]
        add     ecx,4
        movsx   eax,word ptr [dbg_op1.bd]
        add     eax,ecx
        bswap   eax
        mov     [Dregs + 15 * 4],eax
        inc     [changeofflow]
        clc
	ret
i_rtd ENDP
i_rts PROC
        mov     ecx,[Dregs + 15 * 4]
        bswap   ecx
        mov     edx,[membase]
        mov     esi,[ecx + edx]
        bswap   esi
        add     esi,[membase]
        add     ecx,4
        bswap   ecx
        mov     [Dregs + 15 * 4],ecx
        inc     [changeofflow]
        clc
	ret
i_rts ENDP
i_trapv PROC
        bt      [SR],V_BIT
        jnc     notrapv
        mov     ax,807h
        jmp     taketrap
notrapv:
        ret
i_trapv ENDP
i_rtr PROC
        mov     ecx,[Dregs + 15 * 4]
        bswap   ecx
        mov     edx,[membase]
        mov     ax,[ecx + edx]
        mov     byte ptr [SR+3],ah
        mov     esi,[ecx + edx+2]
        bswap   esi
        add     esi,[membase]
        add     ecx,6
        bswap   ecx
        mov     [Dregs + 15 * 4],ecx
        inc     [changeofflow]
        clc
	ret
i_rtr ENDP
i_movec PROC
        test    [prm_00],1
        jnz     illoptrap
        bt      [SR],SUPERV_BIT
        jnc     supervtrap
        movzx   eax,[dbg_op2.r1]
        movzx   edx,[dbg_op1.r1]
        mov     edx,[edx*4 + Dregs]
        mov     [eax * 4 + Dregs],edx
        clc
	ret
i_movec ENDP
i_jsr PROC
        mov     ecx,[Dregs + 15 * 4]
        mov     edx,[membase]
        bswap   ecx
        sub     ecx,4
        mov     eax,esi
        sub     eax,edx
        bswap   eax
        mov     [ecx + edx],eax
        bswap   ecx
        mov     [Dregs + 15 * 4],ecx
i_jmp:
        mov     edi,offset dbg_op1
        call    getAddress
        mov     esi,ecx
        inc     [changeofflow]
	ret
i_jsr ENDP
i_dbx PROC
        movzx   eax,byte ptr [firstword+1]
        and     al,15
        mov     cl,byte ptr [SR + 3]
        jmp     [dbtab + eax * 4]
dbtab   label   dword
        dd      dbret
        dd      dbalways
        dd      dbhi,dbls,dbcc,dbcs,dbne,dbeq,dbvc,dbvs,dbpl,dbmi,dbge,dblt
        dd      dbgt,dble
dbhi:
        and     cl,5
        jnz      dbalways
        ret
dbls:
        and     cl,5
        jz      dbalways
        ret
dbcc:
        and     cl,1
        jnz     dbalways
        ret
dbcs:
        and     cl,1
        jz      dbalways
        ret
dbne:
        and     cl,4
        jnz     dbalways
        ret
dbeq:
        and     cl,4
        jz      dbalways
        ret
dbvc:
        and     cl,2
        jnz     dbalways
        ret
dbvs:
        and     cl,2
        jz      dbalways
        ret
dbpl:
        and     cl,8
        jnz     dbalways
        ret
dbmi:
        and     cl,8
        jz      dbalways
        ret
dbgt:
        test    cl,4
        jnz     dbalways
dbge:
        and     cl,0ah
        cmp     cl,2
        jz      dbalways
        cmp     cl,8
        jz      dbalways
        clc
        ret
dble:
        test    cl,4
        jnz     dbret
dblt:
        and     cl,0ah
        jz      dbalways
        cmp     cl,0ah
        jz      dbalways
        clc
        ret
dbalways:
        movzx   eax,byte ptr [dbg_op1.r1]
        lea     eax,[eax * 4 + Dregs]
        mov     cx,[eax+2]
        xchg    ch,cl
        dec     cx
        xchg    ch,cl
        mov     [eax+2],cx
        cmp     cx,-1
        jz      dbret
        mov     esi,[dbg_op2.bd]
        add     esi,[membase]
dbret:
        clc
	ret
i_dbx ENDP
i_trapx PROC
        test    [prm_00],1
        jnz     illoptrap
        movzx   eax,byte ptr [firstword+1]
        and     al,15
        mov     cl,byte ptr [SR + 3]
        jmp     [traptab + eax * 4]
traptab   label   dword
        dd      trapalways
        dd      trapret
        dd      traphi,trapls,trapcc,trapcs,trapne,trapeq,trapvc,trapvs,trappl,trapmi,trapge,traplt
        dd      trapgt,traple
traphi:
        and     cl,5
        jz      trapalways
        ret
trapls:
        and     cl,5
        jnz     trapalways
        ret
trapcc:
        and     cl,1
        jz      trapalways
        ret
trapcs:
        and     cl,1
        jnz     trapalways
        ret
trapne:
        and     cl,4
        jz      trapalways
        ret
trapeq:
        and     cl,4
        jnz     trapalways
        ret
trapvc:
        and     cl,2
        jz      trapalways
        ret
trapvs:
        and     cl,2
        jnz     trapalways
        ret
trappl:
        and     cl,8
        jz      trapalways
        ret
trapmi:
        and     cl,8
        jnz     trapalways
        ret
trapgt:
        test    cl,4
        jnz     trapret
trapge:
        and     cl,0ah
        jz      trapalways
        cmp     cl,0ah
        jz      trapalways
        clc
        ret
traple:
        test    cl,4
        jnz     trapalways
traplt:
        and     cl,0ah
        cmp     cl,2
        jz      trapalways
        cmp     cl,8
        jz      trapalways
        clc
        ret
trapalways:
        mov     ax,807h
        jmp     taketrap
trapret:
        clc
	ret
i_trapx ENDP
i_set PROC
        movzx   eax,byte ptr [firstword+1]
        and     al,15
        mov     cl,byte ptr [SR + 3]
        jmp     [xsettab + eax * 4]
xsettab   label   dword
        dd      xset1
        dd      xset0
        dd      xsethi,xsetls,xsetcc,xsetcs,xsetne,xseteq,xsetvc,xsetvs,xsetpl,xsetmi,xsetge,xsetlt
        dd      xsetgt,xsetle
xsethi:
        and     cl,5
        sete      cl
        jmp     xsetit
xsetls:
        and     cl,5
        setne     cl
        jmp     xsetit
xsetcc:
        and     cl,1
        sete      cl
        jmp     xsetit
xsetcs:
        and     cl,1
        setne   cl
        jmp     xsetit
xsetne:
        and     cl,4
        sete    cl
        jmp     xsetit
xseteq:
        and     cl,4
        setne   cl
        jmp     xsetit
xsetvc:
        and     cl,2
        sete    cl
        jmp     xsetit
xsetvs:
        and     cl,2
        setne   cl
        jmp     xsetit
xsetpl:
        and     cl,8
        sete    cl
        jmp     xsetit
xsetmi:
        and     cl,8
        setne   cl
        jmp     xsetit
xsetgt:
        test    cl,4
        jnz     xsetf
xsetge:
        and     cl,0ah
        jz      xsetf
        cmp     cl,0ah
        jmp     xsetf
xsetle:
        xor     cl,4
        test    cl,4
        jz      xsetf
xsetlt:
        and     cl,0ah
        cmp     cl,2
        jz      xsetf
        cmp     cl,8
        jmp     xsetf
xset1:
        mov     cl,1
        jmp     xsetit
xset0:
        sub     cl,cl
        jmp     xsetit
xsetf:
        sete    cl
xsetit:
        neg     cl
        mov     [thesize],1
        push    ecx
        mov     edi,offset dbg_op1
        call    getAddress
        pop     eax
        jmp     storeValue
i_set ENDP
i_branch PROC
        test    [prm_00],1
        jz      brok
        test    [dbg_op1.mods],EXTBRA
        jnz     illoptrap
brok:
        movzx   eax,byte ptr [firstword+1]
        and     al,15
        mov     cl,byte ptr [SR + 3]
        jmp     [brtab + eax * 4]
brtab   label   dword
        dd      bralways
        dd      brbsr
        dd      brhi,brls,brcc,brcs,brne,breq,brvc,brvs,brpl,brmi,brge,brlt
        dd      brgt,brle
brhi:
        and     cl,5
        jz      bralways
        ret
brls:
        and     cl,5
        jnz     bralways
        ret
brcc:
        and     cl,1
        jz      bralways
        ret
brcs:
        and     cl,1
        jnz     bralways
        ret
brne:
        and     cl,4
        jz      bralways
        ret
breq:
        and     cl,4
        jnz     bralways
        ret
brvc:
        and     cl,2
        jz      bralways
        ret
brvs:
        and     cl,2
        jnz     bralways
        ret
brpl:
        and     cl,8
        jz      bralways
        ret
brmi:
        and     cl,8
        jnz     bralways
        ret
brgt:
        test    cl,4
        jnz     brret
brge:
        and     cl,0ah
        jz      bralways
        cmp     cl,0ah
        jz      bralways
        clc
        ret
brle:
        test    cl,4
        jnz     bralways
brlt:
        and     cl,0ah
        cmp     cl,8
        jz      bralways
        cmp     cl,2
        jz      bralways
        clc
        ret
brbsr:
        mov     ecx,[Dregs + 15 * 4]
        mov     edx,[membase]
        bswap   ecx
        sub     ecx,4
        mov     eax,esi
        sub     eax,edx
        bswap   eax
        mov     [ecx + edx],eax
        bswap   ecx
        mov     [Dregs + 15 * 4],ecx
bralways:
        mov     esi,[dbg_op1.bd]
        add     esi,[membase]
        inc     [changeofflow]
brret:
        clc
	ret
i_branch ENDP
i_div PROC
        mov     [thesize],2
        mov     edi,offset dbg_op1
        call    getAddress
        call    getValue
        or      ax,ax
        jz      wdivtrap
        and     [SR],NOF_MASK
        mov     ecx,eax
        movzx   eax,[dbg_op2.r1]
        lea     ebp,[eax * 4 + Dregs]
        mov     eax,[ebp]
        bswap   eax
        shld    edx,eax,16
        bt      word ptr [firstword+1],0 ; swapped endianness
        jc      divs
        cmp     dx,cx
        jae     divw_ov
        div     cx
        jmp     divjn
divs:
        push    eax
        push    ecx
        or      cx,cx
        jns     divwnoa1
        neg     ecx
divwnoa1:
        or      dx,dx
        jns     divwnoa2
        neg     eax
divwnoa2:
        shr     eax,15
        js      divw_ov2
        cmp     ax,cx
        pop     ecx
        pop     eax
        jae     divw_ov
        idiv    cx
divjn:
        or      ax,ax
        jns     divns
        bts     [SR],N_BIT
divns:
        jnz     divnz
        bts     [SR],Z_BIT
divnz:
        xchg    al,ah
        xchg    dl,dh
        shl     edx,16
        shrd    edx,eax,16
        mov     [ebp],edx
        clc
        ret
divw_ov2:
        pop     ecx
        pop     eax
divw_ov:
        bts     [SR],V_BIT
        clc
        ret
wdivtrap:
        mov     ax,805h
        jmp     taketrap
                
i_div ENDP
i_sbcd PROC
        mov     [thesize],1
        mov     edi,offset dbg_op1
        call    getAddress
        call    getValue
        push    eax
        mov     edi,offset dbg_op2
        call    getAddress
        call    getValue
        pop     edx
        btr     [SR],C_BIT
        btr     [SR],X_BIT
        sbb     al,dl
        das
        jnc     sbcdnc
        bts     [SR],X_BIT
        bts     [SR],C_BIT
sbcdnc:
        jz      sbcdnz
        btr     [SR],Z_BIT
sbcdnz:
        jmp     storeValue
i_sbcd ENDP
i_pack PROC
        test    [prm_00],1
        jnz     illoptrap
        mov     [thesize],2
        mov     edi,offset dbg_op1
        call    getAddress
        call    getValue
        push    eax
        mov     edi,offset dbg_op2
        call    getAddress
        cmp     word ptr [dbg_op2 + operand.xtype],APREDEC
        jnz     ip_nopredec
        dec     ecx
        sub     byte ptr [ebp+3],1
        sbb     byte ptr [ebp+2],0
        sbb     byte ptr [ebp+1],0
        sbb     byte ptr [ebp+0],0
ip_nopredec:
        pop     eax
        add     ax,word ptr [dbg_op3.bd]
        shl     ah,4
        and     al,15
        or      al,ah
        mov     [thesize],1
        jmp     storeValue
i_pack ENDP
i_unpk PROC
        test    [prm_00],1
        jnz     illoptrap
        mov     [thesize],1
        mov     edi,offset dbg_op1
        call    getAddress
        call    getValue
        push    eax
        mov     edi,offset dbg_op2
        call    getAddress
        cmp     word ptr [dbg_op2 + operand.xtype],APREDEC
        jnz     iup_nopredec
        dec     ecx
        dec     ecx
        sub     byte ptr [ebp+3],2
        sbb     byte ptr [ebp+2],0
        sbb     byte ptr [ebp+1],0
        sbb     byte ptr [ebp+0],0
iup_nopredec:
        pop     eax
        mov     ah,al
        shr     ah,4
        and     al,15
        add     ax,word ptr [dbg_op3.bd]
        mov     [thesize],2
        jmp     storeValue
i_unpk ENDP
i_suba PROC
        mov     edi,offset dbg_op1
        call    getAddress
        call    getValue
        cmp     [thesize],SZ_LONG
        jz      subanow
        mov     [thesize],SZ_LONG
        movsx   eax,ax
subanow:
        push    eax
        mov     edi,offset dbg_op2
        call    getAddress
        call    getValue
        pop     edx
        sub     eax,edx
        jmp     storeValue
i_suba ENDP
i_subx PROC
        mov     edi,offset dbg_op1
        call    getAddress
        call    getValue
        push    eax
        mov     edi,offset dbg_op2
        call    getAddress
        call    getValue
        pop     edx
        and     [SR],NOX_MASK
        btr     [SR],X_BIT
        movzx   edi,[thesize]
        jmp     [subxtab + edi*4]
subxtab label   dword
        dd      subxword,subxbyte,subxword,subxlong
subxbyte:
        sbb     al,dl
        jmp     subxcont
subxword:
        sbb     ax,dx
        jmp     subxcont
subxlong:
        sbb     eax,edx
subxcont:
        jnc     subxnocy
        bts     [SR],C_BIT
        bts     [SR],X_BIT
subxnocy:
        jno     subxnoov
        bts     [SR],V_BIT
subxnoov:
        jns     subxnosign
        bts     [SR],N_BIT
subxnosign:
        jnz     subxnoz
        bts     [SR],Z_BIT
subxnoz:
        jmp     storeValue
i_subx ENDP
i_cmpa PROC
        mov     edi,offset dbg_op1
        call    getAddress
        call    getValue
        cmp     [thesize],SZ_LONG
        jz      cmpanow
        mov     [thesize],SZ_LONG
        movsx   eax,ax
cmpanow:
        push    eax
        mov     edi,offset dbg_op2
        call    getAddress
        call    getValue
        pop     edx
        and     [SR],NOX_MASK
        cmp     eax,edx
        jnc     cmpanocy
        bts     [SR],C_BIT
        bts     [SR],X_BIT
cmpanocy:
        jno     cmpanoov
        bts     [SR],V_BIT
cmpanoov:
        jns     cmpanosign
        bts     [SR],N_BIT
cmpanosign:
        jnz     cmpanoz
        bts     [SR],Z_BIT
cmpanoz:
        jmp     storeValue
i_cmpa ENDP
i_mul PROC
        mov     [thesize],2
        mov     edi,offset dbg_op1
        call    getAddress
        call    getValue
        push    eax
        mov     edi,offset dbg_op2
        call    getAddress
        call    getValue
        pop     edx
        and     [SR],NOX_MASK
        bt      [firstword],8
        jc      muls
        mul     dx
        jmp     muljn
muls:
        imul    dx
muljn:
        shl     eax,16
        shrd    eax,edx,16
        or      eax,eax
        jns     mulns
        bts     [SR],N_BIT
mulns:
        jnz     mulnz
        bts     [SR],Z_BIT
mulnz:
        mov     [thesize],SZ_LONG
        jmp     storeValue
i_mul ENDP
i_abcd PROC
        mov     [thesize],1
        mov     edi,offset dbg_op1
        call    getAddress
        call    getValue
        push    eax
        mov     edi,offset dbg_op2
        call    getAddress
        call    getValue
        pop     edx
        btr     [SR],C_BIT
        btr     [SR],X_BIT
        adc     al,dl
        daa
        jnc     abcdnc
        bts     [SR],X_BIT
        bts     [SR],C_BIT
abcdnc:
        jz      abcdnz
        btr     [SR],Z_BIT
abcdnz:
        jmp     storeValue
i_abcd ENDP
i_exg PROC
        movzx   eax,[dbg_op1.r1]
        lea     eax,[Dregs + eax * 4]
        movzx   ecx,[dbg_op2.r1]
        lea     ecx,[Dregs + ecx * 4]
        mov     edx,[ecx]
        mov     ebp,[eax]
        mov     [ecx],ebp
        mov     [eax],edx
        clc
	ret
i_exg ENDP
i_adda PROC
        mov     edi,offset dbg_op1
        call    getAddress
        call    getValue
        cmp     [thesize],SZ_LONG
        jz      addanow
        mov     [thesize],SZ_LONG
        movsx   eax,ax
addanow:
        push    eax
        mov     edi,offset dbg_op2
        call    getAddress
        call    getValue
        pop     edx
        add     eax,edx
        jmp     storeValue
	ret
i_adda ENDP
i_addx PROC
        mov     edi,offset dbg_op1
        call    getAddress
        call    getValue
        push    eax
        mov     edi,offset dbg_op2
        call    getAddress
        call    getValue
        pop     edx
        and     [SR],NOX_MASK
        btr     [SR],X_BIT
        movzx   edi,[thesize]
        jmp     [addxtab + edi*4]
addxtab label   dword
        dd      addxword,addxbyte,addxword,addxlong
addxbyte:
        adc     al,dl
        jmp     addxcont
addxword:
        adc     ax,dx
        jmp     addxcont
addxlong:
        adc     eax,edx
addxcont:
        jnc     addxnocy
        bts     [SR],C_BIT
        bts     [SR],X_BIT
addxnocy:
        jno     addxnoov
        bts     [SR],V_BIT
addxnoov:
        jns     addxnosign
        bts     [SR],N_BIT
addxnosign:
        jnz     addxnoz
        bts     [SR],Z_BIT
addxnoz:
        jmp     storeValue
i_addx ENDP
i_asrb PROC
        mov     edi,offset dbg_op1
        call    getAddress
        call    getValue
        and     [SR],NOF_MASK
        mov     ax,[ecx]        
        xchg    al,ah
        sar     ax,1
        xchg    al,ah
        mov     [ecx],ax
        jnc     asrnoc
        bts     [SR],C_BIT
        bts     [SR],X_BIT
asrnoc:
        jns     asrnos
        bts     [SR],N_BIT
asrnos:
        jnz     asrnoz
        bts     [SR],Z_BIT
asrnoz:
        clc
	ret
i_asrb ENDP
i_aslb PROC
        mov     edi,offset dbg_op1
        call    getAddress
        call    getValue
        and     [SR],NOF_MASK
        and     al,0c0h
        jz      aslnov
        cmp     al,0c0h
        jz      aslnov
        bts     [SR],V_BIT
aslnov:
        mov     ax,[ecx]        
        xchg    al,ah
        sal    ax,1
        xchg    al,ah
        mov     [ecx],ax
        jnc     aslnoc
        bts     [SR],C_BIT
        bts     [SR],X_BIT
aslnoc:
        jns     aslnos
        bts     [SR],N_BIT
aslnos:
        jnz     aslnoz
        bts     [SR],Z_BIT
aslnoz:
        clc
	ret
i_aslb ENDP
i_lsrb PROC
        mov     edi,offset dbg_op1
        call    getAddress
        call    getValue
        and     [SR],NOF_MASK
        mov     ax,[ecx]        
        xchg    al,ah
        shr     ax,1
        xchg    al,ah
        mov     [ecx],ax
        jnc     lsrnoc
        bts     [SR],C_BIT
        bts     [SR],X_BIT
lsrnoc:
        jns     lsrnos
        bts     [SR],N_BIT
lsrnos:
        jnz     lsrnoz
        bts     [SR],X_BIT
lsrnoz:
        clc
	ret
i_lsrb ENDP
i_lslb PROC
        mov     edi,offset dbg_op1
        call    getAddress
        call    getValue
        and     [SR],NOF_MASK
        mov     ax,[ecx]        
        xchg    al,ah
        shl     ax,1
        xchg    al,ah
        mov     [ecx],ax
        jnc     lslnoc
        bts     [SR],C_BIT
        bts     [SR],X_BIT
lslnoc:
        jns     lslnos
        bts     [SR],N_BIT
lslnos:
        jnz     lslnoz
        bts     [SR],Z_BIT
lslnoz:
        clc
	ret
i_lslb ENDP
i_roxrb PROC
        mov     edi,offset dbg_op1
        call    getAddress
        call    getValue
        bt      [SR],X_BIT
        lahf
        and     [SR],NOF_MASK
        sahf
        mov     ax,[ecx]        
        xchg    al,ah
        rcr     ax,1
        xchg    al,ah
        mov     [ecx],ax
        jnc     roxrnoc
        bts     [SR],C_BIT
        bts     [SR],X_BIT
roxrnoc:
        xchg    al,ah
        or      ax,ax
        jns     roxrnos
        bts     [SR],N_BIT
roxrnos:
        jnz     roxrnoz
        bts     [SR],Z_BIT
roxrnoz:
        clc
	ret
i_roxrb ENDP
i_roxlb PROC
        mov     edi,offset dbg_op1
        call    getAddress
        call    getValue
        bt      [SR],X_BIT
        lahf
        and     [SR],NOF_MASK
        sahf
        mov     ax,[ecx]        
        xchg    al,ah
        rcl     ax,1
        xchg    al,ah
        mov     [ecx],ax
        jnc     roxlnoc
        bts     [SR],C_BIT
        bts     [SR],X_BIT
roxlnoc:
        xchg    al,ah
        or      ax,ax
        jns     roxlnos
        bts     [SR],N_BIT
roxlnos:
        jnz     roxlnoz
        bts     [SR],Z_BIT
roxlnoz:
        clc
	ret
i_roxlb ENDP
i_rorb PROC
        mov     edi,offset dbg_op1
        call    getAddress
        call    getValue
        and     [SR],NOF_MASK
        mov     ax,[ecx]        
        xchg    al,ah
        ror     ax,1
        xchg    al,ah
        mov     [ecx],ax
        jnc     rornoc
        bts     [SR],C_BIT
        bts     [SR],X_BIT
rornoc:
        xchg    al,ah
        or      ax,ax
        jns     rornos
        bts     [SR],N_BIT
rornos:
        jnz     rornoz
        bts     [SR],Z_BIT
rornoz:
        clc
	ret
i_rorb ENDP
i_rolb PROC
        mov     edi,offset dbg_op1
        call    getAddress
        call    getValue
        and     [SR],NOF_MASK
        mov     ax,[ecx]        
        xchg    al,ah
        rol     ax,1
        xchg    al,ah
        mov     [ecx],ax
        jnc     rolnoc
        bts     [SR],C_BIT
        bts     [SR],X_BIT
rolnoc:
        xchg    al,ah
        or      ax,ax
        jns     rolnos
        bts     [SR],N_BIT
rolnos:
        jnz     rolnoz
        bts     [SR],Z_BIT
rolnoz:
        clc
	ret
i_rolb ENDP
i_bftst PROC
        test    [prm_00],1
        jnz     illoptrap
        mov     edx,offset dbg_op1
        mov     edi,offset dbg_op2
        jmp     getbf
i_bftst ENDP
i_bfextu PROC
        test    [prm_00],1
        jnz     illoptrap
        mov     edx,offset dbg_op1
        mov     edi,offset dbg_op2
        call    getbf
        and     eax,[masktab + edx*4]
        movzx   ecx,[dbg_op3.r1]
        lea     ecx,[Dregs + ecx * 4]
        bswap   eax
        mov     [ecx],eax
        clc
	ret
i_bfextu ENDP
i_bfchg PROC
        test    [prm_00],1
        jnz     illoptrap
        mov     edx,offset dbg_op1
        mov     edi,offset dbg_op2
        call    getbf
        and     eax,[masktab + edx * 4]
        xor     eax,[masktab + edx * 4]
        mov     edx,offset dbg_op1
        mov     edi,offset dbg_op2
        jmp     storebf
i_bfchg ENDP
i_bfexts PROC
        test    [prm_00],1
        jnz     illoptrap
        mov     edx,offset dbg_op1
        mov     edi,offset dbg_op2
        call    getbf
        movzx   ecx,[dbg_op3.r1]
        lea     ecx,[Dregs + ecx * 4]
        bswap   eax
        mov     [ecx],eax
        clc
	ret
i_bfexts ENDP
i_bfclr PROC
        test    [prm_00],1
        jnz     illoptrap
        mov     edx,offset dbg_op1
        mov     edi,offset dbg_op2
        call    getbf
        sub     eax,eax
        mov     edx,offset dbg_op1
        mov     edi,offset dbg_op2
        jmp     storebf
i_bfclr ENDP
i_bfffo PROC
        test    [prm_00],1
        jnz     illoptrap
        mov     edx,offset dbg_op1
        mov     edi,offset dbg_op2
        call    getbf
        and     eax,[edx*4 + masktab]
        sub     ebp,ebp
        bsr     ebp,eax
        or      ebp,ebp
        jnz     gotbit
        mov     ebp,edx
gotbit:
        add     ebp,ecx
        movzx   eax,[dbg_op3.r1]
        lea     eax,[Dregs + 4 * eax]
        bswap   ebp
        mov     [eax],ebp
        clc
        ret
i_bfffo ENDP
i_bfset PROC
        test    [prm_00],1
        jnz     illoptrap
        mov     edx,offset dbg_op1
        mov     edi,offset dbg_op2
        call    getbf
        mov     eax,[edx*4 + masktab]
        mov     edx,offset dbg_op1
        mov     edi,offset dbg_op2
        jmp     storebf
i_bfset ENDP
i_bfins PROC
        test    [prm_00],1
        jnz     illoptrap 
        movzx   eax,[dbg_op1.r1]
        mov     eax,[Dregs + 4 * eax]
        bswap   eax
             
        mov     edx,offset dbg_op2
        mov     edi,offset dbg_op3
        jmp     storebf
i_bfins ENDP
i_asr PROC
        mov     edi,offset dbg_op1
        call    getAddress
        call    getValue
        mov     ecx,eax
        and     [SR],NOX_MASK
        movzx   ebp,[dbg_op2.r1]
        lea     ebp,[ebp*4 + Dregs]
        mov     eax,[ebp]
        bswap   eax
        movzx   edx,[thesize]
        jmp     [asrtab + edx*4]
asrtab  label   dword
        dd      asrword,asrbyte,asrword,asrlong
asrbyte:
        or      cl,cl
        jz      asrbytechk
        btr     [SR],X_BIT
        sar     al,cl
        jmp     asrlcont
asrbytechk:
        or      al,al
        jmp     asrlcont
        
asrword:
        or      cl,cl
        jz      asrwordchk
        btr     [SR],X_BIT
        sar     ax,cl
        jmp     asrlcont
asrwordchk:
        or      ax,ax
        jmp     asrlcont
asrlong:
        or      cl,cl
        jz      asrlongchk
        btr     [SR],X_BIT
        sar     eax,cl
        jmp     asrlcont
asrlongchk:
        or      eax,eax
asrlcont:
        jnc     asrlnoc
        bts     [SR],X_BIT
        bts     [SR],C_BIT
asrlnoc:
        jns     asrlnos
        bts     [SR],N_BIT
asrlnos:
        jnz     asrlnoz
        bts     [SR],Z_BIT
asrlnoz:
        bswap   eax
        mov     [ebp],eax
        clc
	ret
i_asr ENDP
i_asl PROC
        mov     edi,offset dbg_op1
        call    getAddress
        call    getValue
        mov     ecx,eax
        mov     edx,80000000h
        and     ecx,63
        sar     edx,cl
        and     [SR],NOX_MASK
        movzx   ebp,[dbg_op2.r1]
        lea     ebp,[ebp*4 + Dregs]
        mov     eax,[ebp]
        bswap   eax
        movzx   edx,[thesize]
        jmp     [asltab + edx*4]
asltab label dword
        dd      aslword,aslbyte,aslword,asllong
aslbyte:
        or      cl,cl
        jz      aslbytechk
        shr     edx,24
        mov     edi,edx
        and     dl,al
        jz      aslbnov
        cmp     edx,edi
        jz      aslbnov
        bts     [SR],V_BIT
aslbnov:
        btr     [SR],X_BIT
        sal    al,cl
        jmp     asllcont
aslbytechk:
        or      al,al
        jmp     asllcont
        
aslword:
        or      cl,cl
        jz      aslwordchk
        shr     edx,16
        mov     edi,edx
        and     dx,ax
        jz      aslwnov
        cmp     edx,edi
        jz      aslwnov
        bts     [SR],V_BIT
aslwnov:
        btr     [SR],X_BIT
        sal    ax,cl
        jmp     asllcont
aslwordchk:
        or      ax,ax
        jmp     asllcont
asllong:
        or      cl,cl
        jz      asllongchk
        mov     edi,edx
        and     edx,eax
        jz      asllnov
        cmp     edx,edi
        jz      asllnov
        bts     [SR],V_BIT
asllnov:
        btr     [SR],X_BIT
        sal    eax,cl
        jmp     asllcont
asllongchk:
        or      eax,eax
asllcont:
        jnc     asllnoc
        bts     [SR],X_BIT
        bts     [SR],C_BIT
asllnoc:
        jns     asllnos
        bts     [SR],N_BIT
asllnos:
        jnz     asllnoz
        bts     [SR],Z_BIT
asllnoz:
        bswap   eax
        mov     [ebp],eax
        clc
	ret
i_asl ENDP
i_lsr PROC
        mov     edi,offset dbg_op1
        call    getAddress
        call    getValue
        mov     ecx,eax
        and     [SR],NOX_MASK
        movzx   ebp,[dbg_op2.r1]
        lea     ebp,[ebp*4 + Dregs]
        mov     eax,[ebp]
        bswap   eax
        movzx   edx,[thesize]
        jmp     [lsrtab + edx*4]
lsrtab label dword
        dd      lsrword,lsrbyte,lsrword,lsrlong
lsrbyte:
        or      cl,cl
        jz      lsrbytechk
        btr     [SR],X_BIT
        shr     al,cl
        jmp     lsrlcont
lsrbytechk:
        or      al,al
        jmp     lsrlcont
        
lsrword:
        or      cl,cl
        jz      lsrwordchk
        btr     [SR],X_BIT
        shr     ax,cl
        jmp     lsrlcont
lsrwordchk:
        or      ax,ax
        jmp     lsrlcont
lsrlong:
        or      cl,cl
        jz      lsrlongchk
        btr     [SR],X_BIT
        shr     eax,cl
        jmp     lsrlcont
lsrlongchk:
        or      eax,eax
lsrlcont:
        jnc     lsrlnoc
        bts     [SR],X_BIT
        bts     [SR],C_BIT
lsrlnoc:
        jns     lsrlnos
        bts     [SR],N_BIT
lsrlnos:
        jnz     lsrlnoz
        bts     [SR],Z_BIT
lsrlnoz:
        bswap   eax
        mov     [ebp],eax
        clc
	ret
i_lsr ENDP
i_lsl PROC
        mov     edi,offset dbg_op1
        call    getAddress
        call    getValue
        mov     ecx,eax
        and     [SR],NOX_MASK
        movzx   ebp,[dbg_op2.r1]
        lea     ebp,[ebp*4 + Dregs]
        mov     eax,[ebp]
        bswap   eax
        movzx   edx,[thesize]
        jmp     [lsltab + edx*4]
lsltab label dword
        dd      lslword,lslbyte,lslword,lsllong
lslbyte:
        or      cl,cl
        jz      lslbytechk
        btr     [SR],X_BIT
        shl     al,cl
        jmp     lsllcont
lslbytechk:
        or      al,al
        jmp     lsllcont
        
lslword:
        or      cl,cl
        jz      lslwordchk
        btr     [SR],X_BIT
        shl     ax,cl
        jmp     lsllcont
lslwordchk:
        or      ax,ax
        jmp     lsllcont
lsllong:
        or      cl,cl
        jz      lsllongchk
        btr     [SR],X_BIT
        shl     eax,cl
        jmp     lsllcont
lsllongchk:
        or      eax,eax
lsllcont:
        jnc     lsllnoc
        bts     [SR],X_BIT
        bts     [SR],C_BIT
lsllnoc:
        jns     lsllnos
        bts     [SR],N_BIT
lsllnos:
        jnz     lsllnoz
        bts     [SR],Z_BIT
lsllnoz:
        bswap   eax
        mov     [ebp],eax
        clc
	ret
i_lsl ENDP
i_roxr PROC
        mov     edi,offset dbg_op1
        call    getAddress
        call    getValue
        mov     ecx,eax
        and     [SR],NOX_MASK
        movzx   ebp,[dbg_op2.r1]
        lea     ebp,[ebp*4 + Dregs]
        mov     eax,[ebp]
        bswap   eax
        movzx   edx,[thesize]
        jmp     [roxrtab + edx*4]
roxrtab label dword
        dd      roxrword,roxrbyte,roxrword,roxrlong
roxrbyte:
        or      cl,cl
        jz      roxrbytechk
        btr     [SR],X_BIT
        rcr     al,cl
        movsx   edx,al
        jmp     roxrlcont
roxrbytechk:
        or      al,al
        movsx   edx,al
        jmp     roxrlcont
        
roxrword:
        or      cl,cl
        jz      roxrwordchk
        btr     [SR],X_BIT
        rcr     ax,cl
        movsx   edx,ax
        jmp     roxrlcont
roxrwordchk:
        or      ax,ax
        movsx   edx,ax
        jmp     roxrlcont
roxrlong:
        or      cl,cl
        jz      roxrlongchk
        btr     [SR],X_BIT
        rcr     eax,cl
        mov     edx,eax
        jmp     roxrlcont
roxrlongchk:
        or      eax,eax
        mov     edx,eax
roxrlcont:
        jnc     roxrlnoc
        bts     [SR],X_BIT
        bts     [SR],C_BIT
roxrlnoc:
        or      edx,edx
        jns     roxrlnos
        bts     [SR],N_BIT
roxrlnos:
        jnz     roxrlnoz
        bts     [SR],Z_BIT
roxrlnoz:
        bswap   eax
        mov     [ebp],eax
        clc
	ret
i_roxr ENDP
i_roxl PROC
        mov     edi,offset dbg_op1
        call    getAddress
        call    getValue
        mov     ecx,eax
        and     [SR],NOX_MASK
        movzx   ebp,[dbg_op2.r1]
        lea     ebp,[ebp*4 + Dregs]
        mov     eax,[ebp]
        bswap   eax
        movzx   edx,[thesize]
        jmp     [roxltab + edx*4]
roxltab label dword
        dd      roxlword,roxlbyte,roxlword,roxllong
roxlbyte:
        or      cl,cl
        jz      roxlbytechk
        btr     [SR],X_BIT
        rcl     al,cl
        movsx   edx,al
        jmp     roxllcont
roxlbytechk:
        or      al,al
        movsx   edx,al
        jmp     roxllcont
        
roxlword:
        or      cl,cl
        jz      roxlwordchk
        btr     [SR],X_BIT
        rcl     ax,cl
        movsx   edx,ax
        jmp     roxllcont
roxlwordchk:
        or      ax,ax
        movsx   edx,ax
        jmp     roxllcont
roxllong:
        or      cl,cl
        jz      roxllongchk
        btr     [SR],X_BIT
        rcl     eax,cl
        mov     edx,eax
        jmp     roxllcont
roxllongchk:
        or      eax,eax
        mov     edx,eax
roxllcont:
        jnc     roxllnoc
        bts     [SR],X_BIT
        bts     [SR],C_BIT
roxllnoc:
        or      edx,edx
        jns     roxllnos
        bts     [SR],N_BIT
roxllnos:
        jnz     roxllnoz
        bts     [SR],Z_BIT
roxllnoz:
        bswap   eax
        mov     [ebp],eax
        clc
	ret
i_roxl ENDP
i_ror PROC
        mov     edi,offset dbg_op1
        call    getAddress
        call    getValue
        mov     ecx,eax
        and     [SR],NOX_MASK
        movzx   ebp,[dbg_op2.r1]
        lea     ebp,[ebp*4 + Dregs]
        mov     eax,[ebp]
        bswap   eax
        movzx   edx,[thesize]
        jmp     [rortab + edx*4]
rortab label dword
        dd      rorword,rorbyte,rorword,rorlong
rorbyte:
        or      cl,cl
        jz      rorbytechk
        btr     [SR],X_BIT
        ror     al,cl
        movsx   edx,al
        jmp     rorlcont
rorbytechk:
        or      al,al
        movsx   edx,al
        jmp     rorlcont
        
rorword:
        or      cl,cl
        jz      rorwordchk
        btr     [SR],X_BIT
        ror     ax,cl
        movsx   edx,ax
        jmp     rorlcont
rorwordchk:
        or      ax,ax
        movsx   edx,ax
        jmp     rorlcont
rorlong:
        or      cl,cl
        jz      rorlongchk
        btr     [SR],X_BIT
        ror     eax,cl
        mov     edx,eax
        jmp     rorlcont
rorlongchk:
        or      eax,eax
        mov     edx,eax
rorlcont:
        jnc     rorlnoc
        bts     [SR],X_BIT
        bts     [SR],C_BIT
rorlnoc:
        or      edx,edx
        jns     rorlnos
        bts     [SR],N_BIT
rorlnos:
        jnz     rorlnoz
        bts     [SR],Z_BIT
rorlnoz:
        bswap   eax
        mov     [ebp],eax
        clc
	ret
i_ror ENDP
i_rol PROC
        mov     edi,offset dbg_op1
        call    getAddress
        call    getValue
        mov     ecx,eax
        and     [SR],NOX_MASK
        movzx   ebp,[dbg_op2.r1]
        lea     ebp,[ebp*4 + Dregs]
        mov     eax,[ebp]
        bswap   eax
        movzx   edx,[thesize]
        jmp     [roltab + edx*4]
roltab label dword
        dd      rolword,rolbyte,rolword,rollong
rolbyte:
        or      cl,cl
        jz      rolbytechk
        btr     [SR],X_BIT
        rol     al,cl
        movsx   edx,al
        jmp     rollcont
rolbytechk:
        or      al,al
        movsx   edx,al
        jmp     rollcont
        
rolword:
        or      cl,cl
        jz      rolwordchk
        btr     [SR],X_BIT
        rol     ax,cl
        movsx   edx,ax
        jmp     rollcont
rolwordchk:
        or      ax,ax
        movsx   edx,ax
        jmp     rollcont
rollong:
        or      cl,cl
        jz      rollongchk
        btr     [SR],X_BIT
        rol     eax,cl
        mov     edx,eax
        jmp     rollcont
rollongchk:
        or      eax,eax
        mov     edx,eax
rollcont:
        jnc     rollnoc
        bts     [SR],X_BIT
        bts     [SR],C_BIT
rollnoc:
        or      edx,edx
        jns     rollnos
        bts     [SR],N_BIT
rollnos:
        jnz     rollnoz
        bts     [SR],Z_BIT 
rollnoz:
        bswap   eax
        mov     [ebp],eax
        clc
	ret
i_rol ENDP
exectab LABEL DWORD
        dd i_movep,i_btst,i_bchg,i_bclr,i_bset,i_rtm,i_callm,i_cas2
        dd i_cas,i_cmpchk,i_orccr,i_orsr,i_or,i_andccr,i_andsr,i_and
        dd i_sub,i_add,i_eorccr,i_eorsr,i_eor,i_cmp,i_moves,i_movea
        dd i_move,i_extb,i_lea,i_chk,i_movesr,i_negx,i_moveccr,i_clr
        dd i_neg,i_not,i_ext,i_lnk,i_nbcd,i_swap,i_bkpt,i_pea
        dd i_movem,i_illegal,i_tas,i_tst,i_lmul,i_ldiv,i_trap,i_link
        dd i_unlk,i_moveusp,i_reset,i_nop,i_stop,i_rte,i_rtd,i_rts
        dd i_trapv,i_rtr,i_movec,i_jsr,i_dbx,i_trapx,i_set,i_jmp
        dd i_branch,i_div,i_sbcd,i_pack,i_unpk,i_suba,i_subx,i_cmpa
        dd i_mul,i_abcd,i_exg,i_adda,i_addx,i_asrb,i_aslb,i_lsrb
        dd i_lslb,i_roxrb,i_roxlb,i_rorb,i_rolb,i_bftst,i_bfextu,i_bfchg
        dd i_bfexts,i_bfclr,i_bfffo,i_bfset,i_bfins,i_asr,i_asl,i_lsr
        dd i_lsl,i_roxr,i_roxl,i_ror,i_rol, i_moveq

ExecuteInstruction PROC
        mov     [changeofflow],1
        mov     [badtrapnum],0
        call    dbg_find_opcode
        js      illop
        call    dbg_sz_dispatch
        mov     [thesize],al

        mov     al,[ebx + operand.xsize]
        call    dbg_sz_dispatch
        mov     [thesize],al

        mov     al,[ebx + operand.source]
        mov     edi,offset dbg_op1
        call    dbg_op_dispatch
        jnz     illop

        mov     al,[ebx + operand.dest]
        mov     edi,offset dbg_op2
        call    dbg_op_dispatch
        jnz     illop

        mov     al,[ebx + operand.alt]
        mov     edi,offset dbg_op3
        call    dbg_op_dispatch
        jnz     illop

        test    [prm_00],1
        jz      is020
        cmp     [dbg_op1.xtype],MEM
        jz      illop
        cmp     [dbg_op1.xtype],PCMEM
        jz      illop
        cmp     [dbg_op2.xtype],MEM
        jz      illop
        cmp     [dbg_op2.xtype],PCMEM
        jz      illop
        cmp     [dbg_op3.xtype],MEM
        jz      illop
        cmp     [dbg_op3.xtype],PCMEM
        jz      illop

is020:
        movzx   eax,[ebx + opcode.len]
        add     eax,[oldpc]
        cmp     eax,esi
        jb      keepesi
        xchg    eax,esi

keepesi:

        clc
        movzx   eax,[ebx+opcode.exect]
        call    [eax*4+exectab]
        jc      illop

        btr     [SR],TRACE_BIT
        jc      dotrace 
        btr     [SR],TRACE_BIT2
        jnc     notrace
        test    [prm_00],1
        jnz     notrace
        test    [changeofflow],1
        jz      notrace
dotrace:
        mov     ax,809h
        cmp     [hasvects],1
        jz      traptodbg
        call    taketrap
notrace:    
        clc
        ret
illop:
        test    [stopped],1
        jnz     stopproc
        mov     al,[badtrapnum]
        or      al,al
        jnz     tdb
        mov     al,4
tdb:
        test    [hasvects],1
        jz      traptodbg
        call    illoptrap
        clc
        ret
ExecuteInstruction ENDP
stopproc PROC
        mov     edi,offset StoppedMsg
        call    WriteString
        mov     [stopped],0
        stc
        ret
stopproc ENDP
traptodbg PROC
        push    eax
        mov     edi,offset DebuggerTrap
        call    WriteString
        pop     eax
        call    PrintByte
        stc
        ret
traptodbg ENDP

        end