        .386
        .model  flat,stdcall

include win32.ase
include win32.asi

        public  WriteChar, WriteString,crlf, termio_init, GetKey

        public termio_rundown, UnderlineCurs, BlockCurs, GetCurPos, SetCurPos

        .data
basecurs CONSOLE_CURSOR_INFO <0>
inscurs  CONSOLE_CURSOR_INFO <0>
scrbuf   CONSOLE_SCREEN_BUFFER_INFO <0>

cr      db      13,10,0
outHandle dd       0
inHandle dd     0
writelen dd     0
keyrec keyEvent <0>
count   dd      0
mode    dd      0

        .code
termio_init proc 
        call    GetStdHandle,   STD_OUTPUT_HANDLE
        mov     [outHandle],eax
        call    GetStdHandle,   STD_INPUT_HANDLE
        mov     [inHandle],eax
        call    GetConsoleCursorInfo, [outHandle], offset basecurs
        call    GetConsoleCursorInfo, [outHandle], offset inscurs
        call    GetConsoleMode, [inHandle], offset mode
        mov     eax,[mode]
        and     eax, NOT ENABLE_PROCESSED_INPUT
        call    SetConsoleMode, [inHandle], eax
        ret
termio_init endp

termio_rundown PROC
        test    [outHandle],-1
        jz      norundown
        call    SetConsoleCursorInfo, [outHandle],offset basecurs
        call    SetConsoleMode, [inHandle],mode
norundown:
        ret
termio_rundown ENDP

UnderlineCurs PROC
        mov     [inscurs.dwCursize],10
        call    SetConsoleCursorInfo, [outHandle],offset inscurs
        ret
UnderlineCurs ENDP
BlockCurs PROC
        mov     [inscurs.dwCursize],90
        call    SetConsoleCursorInfo, [outHandle],offset inscurs
        ret
BlockCurs ENDP

GetCurPos PROC
        call    GetConsoleScreenBufferInfo, [outHandle],offset scrbuf
        mov     ax, [scrbuf.dwCPY]
        shl     eax,16
        mov     ax, [scrbuf.dwCPX]
        ret
GetCurPos ENDP
SetCurPos PROC
        call    SetConsoleCursorPosition, [outHandle], eax
        ret
SetCurPos ENDP

WriteChar PROC
        push    edi
        push    ecx
        push    edx
        push    eax
        mov     ecx,esp
        call    WriteFile,       outHandle,ecx,1,offset writelen,0
        pop     eax
        pop     edx
        pop     ecx
        pop     edi
        ret
WriteChar ENDP
WriteString PROC
        push    ecx
        push    edx
        push    edi
        mov     ecx,-1
        mov     al,0
        repne   scasb
        not     ecx
        dec     ecx
        pop     edi
        call    WriteFile,      outHandle,edi,ecx,offset writelen,0
        pop     edx
        pop     ecx
        ret
        
WriteString ENDP
crlf    PROC
        push    edi
        mov     edi,offset cr
        call    WriteString
        pop     edi
        ret
crlf    ENDP

GetKey PROC
        push    ecx
        push    edx
GetKeyL:
        call    GetNumberOfConsoleInputEvents,inHandle,offset count
        or      eax,eax
        jz      gkx
        mov     eax,[count]
        or      eax,eax
        jz      gkx
        call    ReadConsoleInput,inHandle,offset keyrec,1, offset count
        or      eax,eax
        jz      gkx
        mov     eax,[count]
        or      eax,eax
        jz      gkx
        mov     ax,[keyrec.evType]
        cmp     ax,KEY_EVENT
        jnz     GetKeyL
        mov     eax,[keyrec.bKeyDown]
        or      eax,eax
        jz      GetKeyL
        movzx   eax,[keyrec.wChar]
        or      al,al
        jnz     gkx
        movzx   eax,[keyrec.wVirtualKeyCode]
        or      eax,80000000h
gkx:
        pop     edx
        pop     ecx
        ret
GetKey ENDP
        end